SystemOrganization addCategory: #'Morphic-MorphTreeWidget-Examples'!
SystemOrganization addCategory: #'Morphic-MorphTreeWidget'!

AbstractResizerMorph subclass: #MorphTreeResizerMorph
	instanceVariableNames: 'traceMorph oldColor index container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!MorphTreeResizerMorph class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/8/2009 12:31'!
container: aTreeList index: anInteger
	^ self new container: aTreeList index: anInteger! !

!MorphTreeResizerMorph class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/12/2009 19:58'!
fastSplitterResize
	^ true! !

!MorphTreeResizerMorph methodsFor: 'Polymorph-Widgets' stamp: 'AlainPlantec 11/17/2009 16:53'!
adoptPaneColor: paneColor 
	"Change our color too."
	super adoptPaneColor: paneColor.
	self fillStyle: self normalFillStyle! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/27/2009 22:49'!
canResizeColumn
	^(container columns at: index) resizable
! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/8/2009 12:32'!
container: aTreeMorph index: anInteger
	container := aTreeMorph.
	index := anInteger! !

!MorphTreeResizerMorph methodsFor: 'submorphs-add/remove' stamp: 'AlainPlantec 11/3/2009 22:25'!
delete
	super delete.
	self release.
	! !

!MorphTreeResizerMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/17/2009 17:18'!
drawOn: aCanvas
	(owner notNil and: [owner containsPoint: self position])
		ifTrue: [super drawOn: aCanvas]
! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/17/2009 16:57'!
getOldColor
	^ oldColor ifNil: [Color transparent]! !

!MorphTreeResizerMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/18/2009 10:01'!
mouseDown: anEvent 
	"A mouse button has been pressed.
	Update the color for feedback and store the mouse
	position and relative offset to the receiver."
	| cp |
	self canResizeColumn ifFalse: [^ self].
	(self bounds containsPoint: anEvent cursorPoint)
		ifTrue: [oldColor := self color.
			self setGrabbedColor].
	cp := anEvent cursorPoint.
	lastMouse := {cp. cp - self position}! !

!MorphTreeResizerMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/18/2009 10:01'!
mouseEnter: anEvent
	self canResizeColumn ifFalse: [^ self].
	(owner notNil and: [owner bounds containsPoint: anEvent position]) 
		ifTrue: [super mouseEnter: anEvent]! !

!MorphTreeResizerMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/18/2009 10:02'!
mouseLeave: anEvent
	self canResizeColumn ifFalse: [^ self].
	super mouseLeave: anEvent! !

!MorphTreeResizerMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/18/2009 10:01'!
mouseMove: anEvent 
	self canResizeColumn ifFalse: [^ self].
	anEvent hand temporaryCursor
		ifNil: [^ self].
	self class fastSplitterResize
		ifTrue: [traceMorph
				ifNil: [traceMorph := Morph newBounds: self bounds.
					traceMorph borderColor: Color lightGray.
					traceMorph borderWidth: 1.
					self owner addMorph: traceMorph].
			traceMorph position: (anEvent cursorPoint x - lastMouse second x) @ traceMorph position y]
		ifFalse: [self updateFromEvent: anEvent]! !

!MorphTreeResizerMorph methodsFor: 'Polymorph-Widgets' stamp: 'AlainPlantec 11/18/2009 10:01'!
mouseUp: anEvent
	"Change the cursor back to normal if necessary and change the color back to normal."
	
	self canResizeColumn ifFalse: [^ self].
	(self bounds containsPoint: anEvent cursorPoint)
		ifFalse: [anEvent hand showTemporaryCursor: nil].
	self class fastSplitterResize
		ifTrue: [self updateFromEvent: anEvent].
	traceMorph ifNotNil: [traceMorph delete. traceMorph := nil].
	self adoptPaneColor: self paneColor.
	self triggerEvent: #mouseUp! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/18/2009 10:04'!
normalFillStyle
	"Return the normal figlthe receiver."
	^self canResizeColumn
		ifTrue: [self theme splitterNormalFillStyleFor: self]
		ifFalse: [Color transparent]! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 14:09'!
normalizedX: x

	^ x! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 14:09'!
normalizedY: y 
	^y! !

!MorphTreeResizerMorph methodsFor: 'Polymorph-Widgets' stamp: 'AlainPlantec 11/17/2009 17:14'!
paneColor
	^ Color lightGray! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:55'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	^ self theme splitterPressedFillStyleFor: self! !

!MorphTreeResizerMorph methodsFor: 'dependents access' stamp: 'AlainPlantec 11/3/2009 22:26'!
release
	traceMorph := nil.
	oldColor := nil.
	container := nil.
	super release.
	! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:53'!
resizeCursor
	^ Cursor resizeForEdge: #left! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:09'!
setGrabbedColor
	"Set the color of the receiver when it is grabbed."
	
	self fillStyle: self pressedFillStyle! !

!MorphTreeResizerMorph methodsFor: 'Polymorph-Widgets' stamp: 'alain.plantec 3/9/2009 12:55'!
shouldDraw
	^ true! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 07:45'!
splitsTopAndBottom
	^ false! !

!MorphTreeResizerMorph methodsFor: 'Polymorph-Widgets' stamp: 'AlainPlantec 11/17/2009 16:47'!
themeChanged
	"Update the fill style."
	self fillStyle: self normalFillStyle.
	super themeChanged! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/17/2009 16:35'!
updateFromEvent: anEvent 
	"Update the splitter and attached morph positions from
	the mouse event.
	Take into account the mouse down offset."
	| pNew previousX newWidth minX newLeft |
	pNew := anEvent cursorPoint - lastMouse second.
	minX := index = 1 
		ifTrue: [container minResizerX] 
		ifFalse: [(container columnResizers at: index - 1) right + container minResizerOffset].
	newLeft := minX max: pNew x.
	index = 1 
		ifTrue: [newLeft := newLeft + 3].
	self left: newLeft.
	previousX := index = 1
		ifTrue: [container scroller left - container scroller offset x + 3] 
		ifFalse: [(container columnResizers at: index - 1) left].
	newWidth := self left - previousX.
	(container columns at: index) currentWidth: newWidth.
	container resizerChanged! !

ListItemWrapper subclass: #MorphTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

MorphTreeNodeModel subclass: #ClassListNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget-Examples'!

!ClassListNode methodsFor: 'menu' stamp: 'alain.plantec 10/24/2009 23:24'!
browseItem
	ToolSet browse: self item selector: nil! !

!ClassListNode methodsFor: 'accessing' stamp: 'alain.plantec 10/24/2009 23:24'!
classButton
	^ (UITheme current
				newButtonIn: World
				for: self
				getState: nil
				action: #browseItem
				arguments: {}
				getEnabled: #enabled
				getLabel: nil
				help: 'Open a browser on ' translated , self item name)
				label: (UITheme current windowLabelForText: (self item name) , '...');
				yourself! !

!ClassListNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/12/2009 19:32'!
classButtonRow
	^ (UITheme current newRowIn: World for: {self classButton vResizing: #rigid; yourself}) yourself! !

!ClassListNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 16:28'!
commentText
	^ (UITheme current newTextIn: World text: self item comment) unlock; wrapFlag: true; yourself! !

!ClassListNode methodsFor: 'accessing' stamp: 'alain.plantec 10/24/2009 23:24'!
contents
	^ #()! !

!ClassListNode methodsFor: 'menu' stamp: 'alain.plantec 10/24/2009 23:24'!
exploreItem
	self explore! !

!ClassListNode methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:02'!
icon
	^ MenuIcons smallExpertIcon! !

!ClassListNode methodsFor: 'menu' stamp: 'alain.plantec 10/24/2009 23:24'!
inspectItem
	self inspect! !

!ClassListNode methodsFor: 'menu' stamp: 'alain.plantec 10/24/2009 23:24'!
keyStroke: aCharacter from: aTreeMorph 
	aCharacter = $b
		ifTrue: [self browseItem. ^ true].
	aCharacter = $i
		ifTrue: [self inspectItem. ^ true].
	aCharacter = $I
		ifTrue: [self exploreItem. ^ true].
	^ false
! !

!ClassListNode methodsFor: 'menu' stamp: 'alain.plantec 10/24/2009 23:24'!
menu: menu shifted: b 
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browseItem.
	menu
		add: 'Inspect (i)' translated
		target: self
		selector: #inspectItem.
	menu
		add: 'Explore (I)' translated
		target: self
		selector: #exploreItem.
! !

!ClassListNode methodsFor: 'accessing' stamp: 'alain.plantec 10/24/2009 23:24'!
path
	^ self pathIn: OrderedCollection new.! !

!ClassListNode methodsFor: 'accessing' stamp: 'alain.plantec 10/24/2009 23:24'!
pathIn: aCollection 
	self parentNode
		ifNotNil: [(aCollection includes: self parentNode)
		ifFalse: [self parentNode pathIn: aCollection]].
	aCollection add: self.
	^ aCollection! !

MorphTreeNodeModel subclass: #ClassTreeNode
	instanceVariableNames: 'parentNode contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget-Examples'!

!ClassTreeNode methodsFor: 'menu' stamp: 'alain.plantec 9/8/2009 15:04'!
browseItem
	ToolSet browse: self item selector: nil! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:20'!
buildContents
	^ ((self childrenItems asArray sort: [:a :b | a name < b name]) asOrderedCollection
		collect: [:d | self class with: d])
		do: [:c | c parentNode: self] ! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:18'!
childrenItems
	^ (self item subclasses) 
! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 15:17'!
classButton
	^ (UITheme current
				newButtonIn: World
				for: self
				getState: nil
				action: #browseItem
				arguments: {}
				getEnabled: #enabled
				getLabel: nil
				help: 'Open a browser on ' translated , self item name)
				label: (UITheme current windowLabelForText: (self item name) , '...');
				yourself! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 15:15'!
classButtonRow
	^ UITheme current newRowIn: World for: {self classButton}! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/10/2009 09:46'!
commentText
	^ (UITheme current newTextIn: World text: self item comment) unlock; wrapFlag: true; yourself! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:18'!
contents
	^ contents ifNil: [contents := self buildContents]! !

!ClassTreeNode methodsFor: 'menu' stamp: 'alain.plantec 9/8/2009 15:07'!
exploreItem
	self explore! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:05'!
icon
	^  MenuIcons smallExpertIcon! !

!ClassTreeNode methodsFor: 'menu' stamp: 'alain.plantec 9/8/2009 15:06'!
inspectItem
	self inspect! !

!ClassTreeNode methodsFor: 'menu' stamp: 'alain.plantec 9/8/2009 15:11'!
keyStroke: aCharacter from: aTreeMorph 
	aCharacter = $b
		ifTrue: [self browseItem. ^ true].
	aCharacter = $i
		ifTrue: [self inspectItem. ^ true].
	aCharacter = $I
		ifTrue: [self exploreItem. ^ true].
	^ false
! !

!ClassTreeNode methodsFor: 'menu' stamp: 'alain.plantec 9/8/2009 15:06'!
menu: menu shifted: b 
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browseItem.
	menu
		add: 'Inspect (i)' translated
		target: self
		selector: #inspectItem.
	menu
		add: 'Explore (I)' translated
		target: self
		selector: #exploreItem.
! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode
	^ parentNode! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode: aNode
	parentNode := aNode
	! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
path
	^ self pathIn: OrderedCollection new.! !

!ClassTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
pathIn: aCollection 
	self parentNode
		ifNotNil: [(aCollection includes: self parentNode)
		ifFalse: [self parentNode pathIn: aCollection]].
	aCollection add: self.
	^ aCollection! !

!MorphTreeNodeModel methodsFor: 'accessing' stamp: 'AlainPlantec 11/20/2009 21:25'!
color
	^ nil! !

!MorphTreeNodeModel methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 11:12'!
enabled
	^ true! !

!MorphTreeNodeModel methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 14:07'!
model: anObject
	model := anObject! !

SimpleButtonMorph subclass: #MorphTreeColumnButton
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!MorphTreeColumnButton methodsFor: 'dropping/grabbing' stamp: 'AlainPlantec 11/12/2009 12:17'!
acceptDroppingMorph: aMorph event: evt
	self model container swapColumn: self model withColumn: aMorph passenger.
	evt hand releaseMouseFocus: self.
	self noMorePotentialDropTarget.
	self model container changed.
	Cursor normal show.
! !

!MorphTreeColumnButton methodsFor: 'dropping/grabbing' stamp: 'AlainPlantec 11/17/2009 19:05'!
asPotentialDropTarget 
	self model asPotentialDropTarget! !

!MorphTreeColumnButton methodsFor: 'event handling' stamp: 'AlainPlantec 11/12/2009 06:58'!
handlesMouseOverDragging: evt
	^ true! !

!MorphTreeColumnButton methodsFor: 'initialization' stamp: 'AlainPlantec 11/17/2009 14:01'!
initialize
	super initialize.
	self enableDragNDrop: true.
	self fillStyle: (Color veryLightGray).
! !

!MorphTreeColumnButton methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 20:56'!
model
	^ model! !

!MorphTreeColumnButton methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 20:56'!
model: anObject
	model := anObject! !

!MorphTreeColumnButton methodsFor: 'initialization' stamp: 'AlainPlantec 11/11/2009 19:53'!
mouseDown: anEvent
	| selectors |
	selectors := Array 
		with: #click:
		with: nil
		with: nil
		with: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil]).
	anEvent hand waitForClicksOrDrag: self event: anEvent selectors: selectors threshold: 10.
	super mouseDown: anEvent! !

!MorphTreeColumnButton methodsFor: 'event handling' stamp: 'AlainPlantec 11/17/2009 19:05'!
mouseEnterDragging: evt
	(evt hand hasSubmorphs and:[self dropEnabled]) ifFalse: ["no d&d"
		^ super mouseEnterDragging: evt].
	(self wantsDroppedMorph: evt hand firstSubmorph event: evt )
		ifTrue:[
			self asPotentialDropTarget.
		].! !

!MorphTreeColumnButton methodsFor: 'event handling' stamp: 'AlainPlantec 11/12/2009 07:09'!
mouseLeaveDragging: evt
	self noMorePotentialDropTarget ! !

!MorphTreeColumnButton methodsFor: 'event handling' stamp: 'AlainPlantec 11/12/2009 07:09'!
mouseUp: evt
	self noMorePotentialDropTarget.
	super mouseUp: evt! !

!MorphTreeColumnButton methodsFor: 'dropping/grabbing' stamp: 'AlainPlantec 11/17/2009 19:05'!
noMorePotentialDropTarget
	self model noMorePotentialDropTarget! !

!MorphTreeColumnButton methodsFor: 'initialization' stamp: 'AlainPlantec 11/14/2009 08:53'!
startDrag: anEvent
	| trf |
	self dragEnabled ifFalse: [^ self].
	(anEvent hand hasSubmorphs)
		ifTrue: [^ self].
	oldColor 
		ifNotNil: [
			self fillStyle: oldColor.
			oldColor := nil].
	trf := TransferMorph withPassenger: self model from: self.
	anEvent hand grabMorph: trf.
	anEvent hand releaseMouseFocus: self! !

!MorphTreeColumnButton methodsFor: 'dropping/grabbing' stamp: 'AlainPlantec 11/14/2009 08:58'!
wantsDroppedMorph: aMorph event: anEvent 
	^ model container columnDropUnabled and: [(aMorph isKindOf: TransferMorph) and: [(aMorph passenger isKindOf: MorphTreeColumn) and: [aMorph passenger ~= self model]]]! !

Model subclass: #MorphTreeModel
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

MorphTreeModel subclass: #ClassList
	instanceVariableNames: 'roots rootClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget-Examples'!

!ClassList commentStamp: 'AlainPlantec 11/2/2009 16:36' prior: 0!
ClassList new openOn: Collection

!

!ClassList methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/26/2009 07:33'!
keyStroke: aCharacter from: aTreeMorph 
	self selectedNode
		ifNotNil: [:current | current keyStroke: aCharacter from: aTreeMorph]! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/26/2009 07:33'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/15/2009 22:11'!
morphTreeMorphClass
	^ MorphTreeMorph ! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'alain.plantec 10/24/2009 23:15'!
open
	^ self openOn: Object
! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'alain.plantec 10/24/2009 23:15'!
openOn: aClass
	| window |
	self rootClass: aClass.
	window := StandardWindow new model: self.
	window title: aClass name, ' hierarchy'.
	window 
		addMorph: self treeMorph
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).						
	window themeChanged.
	window openInWorld.
	^ window! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'alain.plantec 10/24/2009 23:15'!
rootClass
	^ rootClass ifNil: [rootClass := Object]! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'alain.plantec 10/24/2009 23:15'!
rootClass: aClass
	 rootClass := aClass! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'alain.plantec 10/24/2009 23:15'!
roots
	^ roots ifNil: [roots := self treeRoots]
! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/1/2009 06:16'!
treeMorph
	| treeMorph baseColor oddColor evenColor |
	treeMorph := self morphTreeMorphClass new.
	baseColor := Color lightBlue lighter.
	oddColor := (GradientFillStyle ramp: {
		0.0->baseColor whiter. 0.2->baseColor.
		0.8->baseColor darker. 1.0->baseColor blacker}) radial: false.
	baseColor := Color veryLightGray muchLighter.
	evenColor := (GradientFillStyle ramp: {
		0.0->baseColor lighter lighter. 0.2->baseColor lighter.
		0.8->baseColor. 1.0->baseColor blacker}) radial: false.
	treeMorph
				makeLastColumnUnbounded;
				withHLines: true;
				useSquareCorners;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				hCellInset: 3;
				resizerWidth: 2;
				preferedPaneColor: Color white;
				getMenuSelector: #menu:shifted:;
				columnColorForEven: evenColor odd: oddColor.
	treeMorph	on: self
				list: #roots
				multiSelection: true
				columns: {
					MorphTreeColumn new startWidth: 100;
						rowMorphGetSelector: #classButtonRow;
						headerButtonLabel: 'Class' font:  nil  icon: MenuIcons smallOpenIcon target: nil actionSelector: nil arguments: #().
					MorphTreeColumn new 
						rowMorphGetSelector: #commentText;
					 	headerButtonLabel: 'Comments' font: nil icon: MenuIcons smallPrintIcon target: nil actionSelector: nil arguments: #()
				}.
	^ treeMorph! !

!ClassList methodsFor: 'as yet unclassified' stamp: 'alain.plantec 10/24/2009 23:33'!
treeRoots
	^ (self rootClass allSubclasses asArray sort: [:a :b | a name < b name ]) collect: [:c | ClassListNode with: c]! !

ClassList subclass: #LazyClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget-Examples'!

!LazyClassList methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/15/2009 22:11'!
morphTreeMorphClass
	^ LazyMorphTreeMorph ! !

MorphTreeModel subclass: #ClassTree
	instanceVariableNames: 'roots rootClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget-Examples'!

!ClassTree commentStamp: 'alain.plantec 9/8/2009 15:22' prior: 0!
ClassTree new openOn: Collection
!

!ClassTree methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/26/2009 07:33'!
keyStroke: aCharacter from: aTreeMorph 
	self selectedNode
		ifNotNil: [:current | current keyStroke: aCharacter from: aTreeMorph]! !

!ClassTree methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/26/2009 07:33'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!ClassTree methodsFor: 'as yet unclassified' stamp: 'alain.plantec 9/23/2009 15:32'!
open
	^ self openOn: Object
! !

!ClassTree methodsFor: 'as yet unclassified' stamp: 'alain.plantec 9/23/2009 15:31'!
openOn: aClass
	| window |
	self rootClass: aClass.
	window := StandardWindow new model: self.
	window title: aClass name, ' hierarchy'.
	window 
		addMorph: self treeMorph
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).						
	window themeChanged.
	window openInWorld.
	^ window! !

!ClassTree methodsFor: 'as yet unclassified' stamp: 'alain.plantec 9/8/2009 14:29'!
rootClass
	^ rootClass ifNil: [rootClass := Object]! !

!ClassTree methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/4/2009 09:01'!
rootClass: aClass
	 rootClass := aClass! !

!ClassTree methodsFor: 'as yet unclassified' stamp: 'alain.plantec 9/8/2009 14:05'!
roots
	^ roots ifNil: [roots := self treeRoots]
! !

!ClassTree methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/26/2009 08:34'!
treeMorph
	| treeMorph |
	treeMorph := LazyMorphTreeMorph
			 	on: self
				list: #roots
				multiSelection: true
				columns: {
					MorphTreeColumn new startWidth: 200; rowMorphGetSelector: #classButtonRow. 
					MorphTreeColumn new startWidth: 500; rowMorphGetSelector: #commentText
				}.
	treeMorph
				withHLines: false;
				useSquareCorners;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				preferedPaneColor: Color white;
				autoDeselect: true;
				hCellInset: 4;
				getMenuSelector: #menu:shifted:;
				rowColorForEven: Color lightGray muchLighter;
				arrange.
	^ treeMorph! !

!ClassTree methodsFor: 'as yet unclassified' stamp: 'alain.plantec 9/8/2009 14:33'!
treeRoots
	^ OrderedCollection with: (ClassTreeNode with: self rootClass) ! !

!MorphTreeModel methodsFor: 'menu' stamp: 'AlainPlantec 10/29/2009 15:53'!
keyStroke: aCharacter from: aTreeMorph! !

!MorphTreeModel methodsFor: 'menu' stamp: 'AlainPlantec 12/9/2009 15:35'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	^ menu! !

!MorphTreeModel methodsFor: 'menu' stamp: 'AlainPlantec 10/29/2009 12:19'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then
perform it on myself. If not, send it to otherTarget, presumably the
editPane from which the menu was invoked."

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!MorphTreeModel methodsFor: 'accessing' stamp: 'AlainPlantec 11/19/2009 13:51'!
roots
	^ #()! !

!MorphTreeModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 08:15'!
selectAllNodePaths: aCollectionOfNodePath
	self selection: (MorphTreeMorphMultipleSelection new selectedNodePathList: aCollectionOfNodePath)! !

!MorphTreeModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 07:13'!
selectNodePath: aNodePath
	self selection: (MorphTreeMorphSingleSelection new selectedNodePath: aNodePath)! !

!MorphTreeModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 07:34'!
selectedItem
	^ self selectedNode ifNotNil: [:node | node item]! !

!MorphTreeModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 07:29'!
selectedNode
	^ self selectedNodePath ifNotNil: [:path | path last]! !

!MorphTreeModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 07:25'!
selectedNodePath
	^ selection ifNotNil: [selection lastSelectedNodePath]! !

!MorphTreeModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/18/2009 08:17'!
selection
	^ selection.
! !

!MorphTreeModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 09:52'!
selection: aSelection
	selection := aSelection.
	self changed: #selection.
	(aSelection notNil and: [aSelection lastSelectedNode notNil])
		ifTrue: [aSelection lastSelectedNode sendSettingMessageTo: self]
! !

TransformMorph subclass: #MorphTreeTransformMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!MorphTreeTransformMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/20/2009 21:27'!
drawRawColorOn: aCanvas forSubmorph: aSubMorph
	| c |
	aSubMorph isSelected ifTrue: [^ self].
	c := aSubMorph color ifNil: [^ self].
	c isColor
		ifTrue: [
			aCanvas 
				frameAndFillRectangle: (aSubMorph fullBounds withRight: owner right)
				fillColor: c
				borderWidth: 0 
				borderColor: Color transparent]
		ifFalse: [c origin: aSubMorph bounds topLeft.
				c direction: aSubMorph bounds width@0.
				aCanvas fillRectangle: (aSubMorph fullBounds  withRight: owner right) basicFillStyle: c]! !

!MorphTreeTransformMorph methodsFor: 'drawing' stamp: 'AlainPlantec 12/10/2009 17:39'!
drawSubmorphsOn: aCanvas
	| idx |
	aCanvas transformBy: transform
		clippingTo: (aCanvas clipRect intersect: self clippingBounds)
		during: [:myCanvas | submorphs do:[:m | 
				(myCanvas isVisible: m fullBounds) 
					ifTrue: [self drawRawColorOn: myCanvas forSubmorph: m.
						myCanvas fullDrawMorph: m] ] ]
		smoothing: smoothing.
	self  theme treeLineWidth > 0 ifTrue: [owner drawLinesOn: aCanvas].
! !

!MorphTreeTransformMorph methodsFor: 'layout' stamp: 'AlainPlantec 11/16/2009 11:05'!
fullBounds
	"Overridden to clip submorph hit detection to my bounds."
	"It might be better to override doLayoutIn:, and remove this method"

	fullBounds ifNotNil:[^ fullBounds].
	fullBounds := bounds.
	^ fullBounds! !

!MorphTreeTransformMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/19/2009 16:28'!
initialize
	super initialize.
! !

!MorphTreeTransformMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/16/2009 11:15'!
localSubmorphBounds
	"Answer, in my coordinate system, the bounds of all my visible submorphs (or nil if no visible submorphs)"
	| subBounds |
	self hasSubmorphs ifFalse: [^ nil].
	subBounds := self firstSubmorph fullBounds copy.
	(2 to: submorphs size) do: [:idx |
		subBounds := subBounds quickMerge: (submorphs at: idx) fullBounds].
	^subBounds! !

Morph subclass: #MorphTreeNodeMorph
	instanceVariableNames: 'parent index indentLevel isExpanded complexContents firstChild container nextSibling icon rowMorph controls spacers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

MorphTreeNodeMorph subclass: #LazyMorphTreeNodeMorph
	instanceVariableNames: 'drawable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!LazyMorphTreeNodeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/20/2009 07:27'!
drawOn: aCanvas
	drawable
		ifFalse: [container buildRowMorphsFrom: self]
		ifTrue: [super drawOn: aCanvas]
! !

!LazyMorphTreeNodeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/19/2009 16:50'!
drawSubmorphsOn: aCanvas
	drawable ifFalse: [^ self].
	super drawSubmorphsOn: aCanvas.
! !

!LazyMorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/19/2009 18:33'!
drawable
	^ drawable ifNil: [false]
! !

!LazyMorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/16/2009 10:20'!
drawable: aBoolean
	drawable := aBoolean.
! !

!LazyMorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/15/2009 22:09'!
initRow! !

!LazyMorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/15/2009 23:01'!
initialize
	super initialize.
	drawable := false! !

!MorphTreeNodeMorph methodsFor: 'drag and drop' stamp: 'alain.plantec 3/7/2009 09:29'!
acceptDroppingMorph: toDrop event: evt
	complexContents acceptDroppingObject: toDrop complexContents.
	toDrop delete.
	self highlightForDrop: false.! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'AlainPlantec 11/15/2009 15:10'!
addChildrenForList: hostList addingTo: morphList withExpandedItems: expandedItems

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode delete].
	].
	firstChild := nil.
	complexContents hasContents ifFalse: [^self].
	firstChild := hostList 
		addMorphsTo: morphList
		from: complexContents contents 
		allowSorting: true
		withExpandedItems: expandedItems
		atLevel: indentLevel + 1.
	! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/15/2009 17:18'!
adoptPaneColor: aColor! !

!MorphTreeNodeMorph methodsFor: 'enumeration' stamp: 'alain.plantec 10/24/2009 23:09'!
anySiblingSatisfy: aBlock
	(self parent ifNil: [container]) childrenDo: [:c | (aBlock value: c) ifTrue: [^ true]].
	^ false! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
balloonText

	^complexContents balloonText ifNil: [super balloonText]! !

!MorphTreeNodeMorph methodsFor: 'halos and balloon help' stamp: 'alain.plantec 3/7/2009 09:29'!
boundsForBalloon

	"some morphs have bounds that are way too big"
	container ifNil: [^super boundsForBalloon].
	^self boundsInWorld intersect: container boundsInWorld! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/20/2009 08:22'!
buildRowMorph
	| spacer rowControls colAndControls |
	rowMorph ifNotNil: [^ rowMorph ].
	rowMorph := Morph new.
	rowMorph "clipSubmorphs: true;"
		beSticky;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 0.
	self addMorphBack: (spacer := self transparentSpacerOfSize: self spacerWidth @ 1).
	colAndControls := container columns collect: [:col | col -> (col rowMorphFor: complexContents)].
	controls := colAndControls collect: [:c | c value].
	spacers := spacer asOrderedCollection.
	rowControls := OrderedCollection new.
	colAndControls
		do: [:ctrl | | col morph |
			col := ctrl key.
			morph := ctrl value.
			morph clipSubmorphs: true.
			rowControls add: morph.
			(morph = controls last and: [container lastColumnUnbounded]) ifFalse: [morph hResizing: #rigid].
			(col resizable not and: [col shrinkWrap])
				ifTrue: [col currentWidth < morph width 
						ifTrue: [col forceWidthTo: morph width. 
							container resizerChanged]]]
		separatedBy: [rowControls add: (self transparentSpacerOfSize: (container resizerWidth + 3 + (container hCellInset * 2)) @ 1).
			spacers add: rowControls last].
	rowMorph addAllMorphs: rowControls.
	self addMorphBack: rowMorph.
	^ rowMorph
	
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
canExpand

	^complexContents hasContents! !

!MorphTreeNodeMorph methodsFor: 'updating' stamp: 'alain.plantec 3/12/2009 09:48'!
changed
	"Need to invalidate the selection frame."
	container
		ifNil: [super changed] 
		ifNotNil: [self invalidRect: self selectionFrame]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
children
	| children |
	children := OrderedCollection new.
	self childrenDo: [:each | children add: each].
	^children! !

!MorphTreeNodeMorph methodsFor: 'enumeration' stamp: 'alain.plantec 3/7/2009 09:29'!
childrenDo: aBlock

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aBlock value: aNode].
	]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/27/2009 22:20'!
closeItemPath: anArray
	"Close a path based on wrapper item equivalence."
	
	| found |
	anArray isEmpty
		ifTrue: [^ container setSelectedMorph: nil].
	found := nil.
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents withoutListWrapper = anArray first)
						ifTrue: [found := each]]].
	found
		ifNotNil: [(found isExpanded and: [anArray size = 1])
				ifTrue: [found toggleExpandedState.
					container adjustSubmorphPositions].
			found changed.
			anArray size = 1
				ifTrue: [^ container setSelectedMorph: found].
			^ found firstChild
				ifNil: [container setSelectedMorph: nil]
				ifNotNil: [found firstChild closeItemPath: anArray allButFirst]].
	^container setSelectedMorph: nil! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/20/2009 21:24'!
color
	^ complexContents color ifNil: [container rowColors at: ((self index \\ 2) + 1)]! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 12/2/2009 17:27'!
columnMorphAt: anIndex
	^ controls at: anIndex ! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
complexContents

	^complexContents! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/9/2009 19:36'!
controls
	^ controls! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/8/2009 12:27'!
delete
	parent := nil.
	complexContents := nil.
	firstChild := nil.
	container := nil.
	nextSibling := nil.
	icon := nil.
	rowMorph ifNotNil: [rowMorph delete. rowMorph := nil].
	controls := nil.
	spacers := nil.
	super delete.
! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 10/23/2009 10:40'!
drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"If I am not the only item in my container, draw the line between:
		- my toggle (if any) or my left edge (if no toggle)
		- and my text left edge.
	Only draw now if no toggle."

	| myBounds myCenter hLineY hLineLeft myTheme|
	self isSoleItem ifTrue: [ ^self ].
	self hasToggle ifTrue: [^self].
	myBounds := self toggleRectangle.
	myCenter := myBounds center.
	hLineY := myCenter y - 1.
	hLineLeft := myCenter x.
	"Draw line from toggle to text. Use optimised form since vertical."
	myTheme := self theme.
	aCanvas
		frameRectangle: (hLineLeft @ hLineY corner: myBounds right + 3 @ (hLineY + 1))
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/9/2009 11:03'!
drawLinesOn: aCanvas lineColor: lineColor 
	| hasToggle |
	hasToggle := self hasToggle.
	"Draw line from toggle to text"
	self drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle.

	"Draw the line from my toggle to the nextSibling's toggle"
	self nextSibling ifNotNil: [ self drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle ].

	"If I have children and am expanded, draw a line to my first child"
	(self firstChild notNil and: [ self isExpanded ])
		ifTrue: [ self drawLinesToFirstChildOn: aCanvas lineColor: lineColor]! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 10/23/2009 10:41'!
drawLinesToFirstChildOn: aCanvas lineColor: lineColor 
	"Draw line from me to first child.
	Don't bother if the first child has a toggle.."

	| vLineX vLineTop vLineBottom childBounds childCenter myTheme|
	self firstChild hasToggle ifTrue: [^self].
	childBounds := self firstChild toggleRectangle.
	childCenter := childBounds center.
	vLineX := childCenter x.
	vLineTop := bounds bottom.
	self firstChild hasToggle
		ifTrue: [vLineBottom := childCenter y - (childBounds height // 2) + 1]
		ifFalse: [vLineBottom := childCenter y - 2].
	myTheme := self theme.
	aCanvas
		frameRectangle: (vLineX @ vLineTop corner: vLineX + 1 @ vLineBottom)
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 10/23/2009 10:41'!
drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"Draw line from me to next sibling"
	
	| myBounds nextSibBounds vLineX myCenter vLineTop vLineBottom myTheme|
	myBounds := self toggleRectangle.
	nextSibBounds := self nextSibling toggleRectangle.
	myCenter := myBounds center.
	vLineX := myCenter x.
	vLineTop := myCenter y + 1.
	vLineBottom := nextSibBounds center y - 1.
	"Draw line from me to next sibling"
	myTheme := self theme.
	aCanvas
		frameRectangle: (vLineX @ vLineTop corner: vLineX + 1 @ vLineBottom)
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/8/2009 13:49'!
drawMouseDownHighlightOn: aCanvas
	"Draw with a dotted border."
	
	|frame|
	self highlightedForMouseDown ifTrue: [
		container ifNil: [^super drawMouseDownHighlightOn: aCanvas].
		frame := self selectionFrame.
		aCanvas 
			frameRectangle: frame
			width: 1
			colors: {container mouseDownHighlightColor. Color transparent}
			 dashes: #(1 1)]! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 10/28/2009 14:10'!
drawOn: aCanvas 
	| tRect sRect |
	container withHLines ifTrue: [
		aCanvas 
			frameRectangle: self selectionFrame
			width: 1
			colors: {Color veryLightGray. Color transparent}
			 dashes: #(1 2)].
	tRect := self toggleRectangle.
	self hasToggle ifTrue: [self drawToggleOn: aCanvas in: tRect].
	self mustTakeIntoAccountToggleSpace 
		ifTrue: [sRect := bounds withLeft: tRect right + container gapAfterToggle]
		ifFalse: [sRect := bounds withLeft: tRect left].
	self hasIcon ifTrue: [aCanvas translucentImage: icon at: sRect left @ (self top + (self height - icon height // 2))].

! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 10/24/2009 22:54'!
drawToggleOn: aCanvas in: aRectangle

	| aForm centeringOffset |
	aForm := isExpanded 
		ifTrue: [container expandedForm]
		ifFalse: [container notExpandedForm].
	centeringOffset := ((aRectangle height - aForm extent y) / 2.0) truncated.
	^aCanvas 
		translucentImage: aForm 
		at: (aRectangle topLeft translateBy: 0 @ centeringOffset).
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
firstChild

	^firstChild! !

!MorphTreeNodeMorph methodsFor: 'events-processing' stamp: 'AlainPlantec 11/26/2009 09:42'!
handleMouseUp: anEvent
	(container commandOrCrontrolKeyPressed: anEvent) ifTrue: [^ container mouseUp: anEvent onMorph: self].
	^ super handleMouseUp: anEvent! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
hasIcon
	"Answer whether the receiver has an icon."
	^ icon notNil! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 10/23/2009 12:15'!
hasToggle
	^ self canExpand! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'AlainPlantec 11/1/2009 18:55'!
highlight

	complexContents highlightingColor ifNotNil: [:c | self color: c. self changed]
	
! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/26/2009 09:47'!
highlightForMouseDown: aBoolean
	aBoolean 
		ifTrue:[self setProperty: #highlightedForMouseDown toValue: aBoolean]
		ifFalse:[self removeProperty: #highlightedForMouseDown].
	self changed! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
icon
	"answer the receiver's icon"
	^ icon! !

!MorphTreeNodeMorph methodsFor: 'mouse events' stamp: 'alain.plantec 3/7/2009 09:29'!
inToggleArea: aPoint

	^self toggleRectangle containsPoint: aPoint! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/10/2009 13:16'!
indentGap
	^ container indentGap * indentLevel! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
indentLevel

	^indentLevel! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/20/2009 17:19'!
index
	^ index ! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/20/2009 17:19'!
index: anInteger
	index := anInteger! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/20/2009 08:22'!
initRow
	self buildRowMorph.
	! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/25/2009 11:23'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel 
	self layoutInset: hostList hCellInset @ hostList vCellInset.
	container := hostList.
	complexContents := anObject.
	isExpanded := false.
	nextSibling := firstChild := nil.
	priorMorph ifNotNil: [priorMorph nextSibling: self].
	indentLevel := newLevel.
	icon := complexContents icon.
	icon ifNotNil: [container iconReservedExtent: icon extent].
	self initRow
	! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 12/2/2009 17:19'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self layoutPolicy: TableLayout new.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	self listDirection: #leftToRight.
	self cellPositioning: #topLeft.
	self color: Color transparent.
	self cellInset: 0.! !

!MorphTreeNodeMorph methodsFor: 'updating' stamp: 'alain.plantec 3/12/2009 11:43'!
innerWidgetChanged
	container ifNotNil: [container innerWidgetChanged]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isExpanded

	^isExpanded! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isExpanded: aBoolean

	isExpanded := aBoolean! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isFirstItem
	^owner submorphs first == self! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:48'!
isSelected
	^ container selectedMorphList includes: self! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isSoleItem
	^self isFirstItem and: [ owner submorphs size = 1 ]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
lastChild
	"Answer the last child."

	|c|
	c := self firstChild ifNil: [^nil].
	[c nextSibling isNil] whileFalse: [c := c nextSibling].
	^c! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/15/2009 13:10'!
minHeight
	"Answer the minimum height of the receiver."
	
	| iconHeight |
	iconHeight := self hasIcon
				ifTrue: [self icon height + 2]
				ifFalse: [0].
	^(iconHeight) max: super minHeight! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/15/2009 13:10'!
minWidth
	"Fixed to work such that guessed width is unnecessary in
	#adjustSubmorphPositions."

	| iconWidth |
	iconWidth := self hasIcon
				ifTrue: [self icon width + 2]
				ifFalse: [0].
	^(13 * indentLevel + 15 + iconWidth) max: super minWidth! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'AlainPlantec 10/28/2009 22:57'!
mustTakeIntoAccountToggleSpace
	^ indentLevel > 0 or: [	container hasToggleAtRoot]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
nextSibling

	^nextSibling! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
nextSibling: anotherMorph

	nextSibling := anotherMorph! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/27/2009 22:15'!
openItemPath: anArray
	"Open a path based on wrapper item equivalence. Generally more specific
	than #openPath: (string based)."
	
	| found |
	anArray isEmpty
		ifTrue: [^ container setSelectedMorph: nil].
	found := nil.
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents withoutListWrapper = anArray first
							or: [anArray first isNil])
						ifTrue: [found := each]]].
	found
		ifNotNil: [found isExpanded
				ifFalse: [found toggleExpandedState.
					container adjustSubmorphPositions].
			found changed.
			anArray size = 1
				ifTrue: [^ container setSelectedMorph: found].
			^ found firstChild
				ifNil: [container setSelectedMorph: nil]
				ifNotNil: [found firstChild openItemPath: anArray allButFirst]].
	^container setSelectedMorph: nil! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
openPath: anArray 
	| found |
	anArray isEmpty
		ifTrue: [^ container setSelectedMorph: nil].
	found := nil.
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents asString = anArray first
							or: [anArray first isNil])
						ifTrue: [found := each]]].
	found
		ifNil: ["try again with no case sensitivity"
			self
				withSiblingsDo: [:each | found
						ifNil: [(each complexContents asString sameAs: anArray first)
								ifTrue: [found := each]]]].
	found
		ifNotNil: [found isExpanded
				ifFalse: [found toggleExpandedState.
					container adjustSubmorphPositions].
			found changed.
			anArray size = 1
				ifTrue: [^ container setSelectedMorph: found].
			^ found firstChild
				ifNil: [container setSelectedMorph: nil]
				ifNotNil: [found firstChild openPath: anArray allButFirst]].
	^ container setSelectedMorph: nil! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
outerBounds
	"Return the 'outer' bounds of the receiver, e.g., the bounds that need to be invalidated when the receiver changes."
	
	|box|
	box := super outerBounds.
	container ifNil: [^box].
	^box left: (box left min: self selectionFrame left)! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 10/23/2009 15:35'!
parent
	^ parent! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 10/23/2009 15:36'!
parent: aNodeMorph
	parent := aNodeMorph! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 16:44'!
path
	^ parent 
		ifNil: [OrderedCollection with: self]
		ifNotNil: [(parent path) add: self; yourself]! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
recursiveAddTo: aCollection

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveAddTo: aCollection].
	].
	aCollection add: self
	! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
recursiveDelete

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveDelete].
	].
	self delete
	! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/12/2009 06:42'!
rowMorphAt: anIndex
	^ self submorphs seconds submorphs at: anIndex! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:56'!
selectNodePath: anArray
	"select a node from a path based on wrapper node equivalence"
	
	| found |
	anArray isNil ifTrue: [^ self].
	anArray isEmpty ifTrue: [^ self].
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents = anArray first
							or: [anArray first isNil])
						ifTrue: [found := each]]].
	found
		ifNotNil: [
			anArray size = 1
				ifTrue: [^ container addSelectedMorph: found].
			found firstChild
				ifNotNil: [:fc | fc selectNodePath: anArray allButFirst]].
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 12/1/2009 07:26'!
selectionFrame
	"Answer the selection frame rectangle."

	|frame|
	frame := self bounds: self bounds in: container.
	frame := self
		bounds: ((frame left: container innerBounds left) right: container innerBounds right)
		from: container.
	^frame! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/17/2009 09:16'!
spacerWidth	
	| sRect  |
	sRect := bounds.
	self mustTakeIntoAccountToggleSpace 
		ifTrue: [sRect := sRect withLeft: self toggleRectangle right + container gapAfterToggle]
		ifFalse: [sRect := sRect withLeft: self toggleRectangle left].
	self icon 
		ifNotNil: [sRect := sRect withLeft: sRect left + container iconReservedExtent x + container gapAfterIcon].
	^ sRect left - bounds left.
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
theme
	"Answer the ui theme that provides controls.
	Done directly here to avoid performance hit of
	looking up in window."

	^UITheme current! !

!MorphTreeNodeMorph methodsFor: 'updating' stamp: 'AlainPlantec 11/15/2009 17:18'!
themeChanged! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 3/7/2009 09:29'!
toggleBounds
	^self toggleRectangle! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'AlainPlantec 11/26/2009 08:01'!
toggleExpandedState

 	| newChildren toDelete c |

	isExpanded := isExpanded not.
	toDelete := OrderedCollection new.
	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveAddTo: toDelete].
	].
	container noteRemovalOfAll: toDelete.
	(isExpanded and: [complexContents hasContents]) ifFalse: [
		^self changed
	].
	(c := complexContents contents) isEmpty ifTrue: [^self changed].
	newChildren := container 
		addMorphsAfter: self 
		fromCollection: c 
		allowSorting: true.
	firstChild := newChildren first.
	self childrenDo: [:child | child parent: self]
	
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 17:54'!
toggleImageMorph
	^ ImageMorph new
		image: (isExpanded
				ifTrue: [container expandedForm]
				ifFalse: [container notExpandedForm]) ! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/28/2009 14:12'!
toggleRectangle
	^(bounds left + self indentGap) @ bounds top extent: container toggleImageWidth @ bounds height! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
unhighlight

	complexContents highlightingColor ifNotNil: [self color: Color black].
	self changed.
	
	
! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'AlainPlantec 10/31/2009 08:51'!
updateChildren
	self childrenDo: [:child | child parent: self]
	
! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'AlainPlantec 11/20/2009 17:29'!
updateChildrenRecursively
	self childrenDo: [:child | child parent: self. 
		child updateChildrenRecursively]
	
! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/17/2009 15:54'!
updateColumnMorphsWidthWith: aListOfWidths
	|  spacersCopy |
	(container columns isEmpty or: [self hasSubmorphs not]) ifTrue: [^ self].
	spacersCopy := spacers copy.
	spacersCopy removeFirst width: self spacerWidth.
	aListOfWidths withIndexDo: 
		[:w :idx | (controls at: idx) width: (w - (idx = 1 ifTrue: [self spacerWidth] ifFalse: [0]))].
	[spacersCopy isEmpty] 
		whileFalse: [spacersCopy removeFirst width: container resizerWidth + 3 + (container hCellInset * 2)]
! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 3/7/2009 09:29'!
withSiblingsDo: aBlock

	| node |
	node := self.
	[node isNil] whileFalse: [
		aBlock value: node.
		node := node nextSibling
	].! !

!MorphTreeNodeMorph methodsFor: 'converting' stamp: 'alain.plantec 3/7/2009 09:29'!
withoutListWrapper

	^complexContents withoutListWrapper! !

ScrollPane subclass: #MorphTreeMorph
	instanceVariableNames: 'getListSelector setSelectionSelector keystrokeActionSelector autoDeselect columns sortingSelector potentialDropMorph lineColor hCellInset vCellInset columnResizers withHLines preferedPaneColor indentGap expandedToggleImage notExpandedToggleImage resizerWidth gapAfterIcon gapAfterToggle hasToggleAtRoot scrollDeltaHeight getSelectionSelector topHeader topHeaderBackground unboundLastColumn columnDropUnabled iconReservedExtent columnColors rowColors allowsMultipleSelection selectedMorphList lastSelectedMorph doubleClickSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!MorphTreeMorph commentStamp: 'AlainPlantec 11/21/2009 14:06' prior: 0!
A MorphTreeMorph display a tree or a list of morphs into a scrollable area. A row can be displayed with columns separated by a resizer. 
A MorphTreeMorph can have a top header composed of buttons, one button per column. 
Such a button can have an icon and/or a title and may run some action when clicked on. A typical action is the ordering of the list.


Instance Variables
	allowsMultipleSelection:		<Object>
	autoDeselect:		<Object>
	columnColors:		<Object>
	columnDropUnabled:		<Object>
	columnResizers:		<Object>
	columns:		<Object>
	expandedToggleImage:		<Object>
	gapAfterIcon:		<Object>
	gapAfterToggle:		<Object>
	getListSelector:		<Object>
	getSelectionSelector:		<Object>
	hCellInset:		<Object>
	hasToggleAtRoot:		<Object>
	iconReservedExtent:		<Object>
	indentGap:		<Object>
	keystrokeActionSelector:		<Object>
	lastSelectedNode:		<Object>
	lineColor:		<Object>
	notExpandedToggleImage:		<Object>
	potentialDropMorph:		<Object>
	preferedPaneColor:		<Object>
	resizerWidth:		<Object>
	scrollDeltaHeight:		<Object>
	selectedNodes:		<Object>
	setSelectionSelector:		<Object>
	sortingSelector:		<Object>
	topHeader:		<Object>
	topHeaderBackground:		<Object>
	unboundLastColumn:		<Object>
	vCellInset:		<Object>
	withHLines:		<Object>

allowsMultipleSelection
	- xxxxx

autoDeselect
	- xxxxx

columnColors
	- xxxxx

columnDropUnabled
	- xxxxx

columnResizers
	- xxxxx

columns
	- xxxxx

expandedToggleImage
	- xxxxx

gapAfterIcon
	- xxxxx

gapAfterToggle
	- xxxxx

getListSelector
	- xxxxx

getSelectionSelector
	- xxxxx

hCellInset
	- xxxxx

hasToggleAtRoot
	- xxxxx

iconReservedExtent
	- xxxxx

indentGap
	- xxxxx

keystrokeActionSelector
	- xxxxx

lastSelectedNode
	- xxxxx

lineColor
	- xxxxx

notExpandedToggleImage
	- xxxxx

potentialDropMorph
	- xxxxx

preferedPaneColor
	- xxxxx

resizerWidth
	- xxxxx

scrollDeltaHeight
	- xxxxx

selectedNodes
	- xxxxx

setSelectionSelector
	- xxxxx

sortingSelector
	- xxxxx

topHeader
	- xxxxx

topHeaderBackground
	- xxxxx

unboundLastColumn
	- xxxxx

vCellInset
	- xxxxx

withHLines
	- xxxxx
!

MorphTreeMorph subclass: #LazyMorphTreeMorph
	instanceVariableNames: 'lazyIncrement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!LazyMorphTreeMorph methodsFor: 'lazy tree' stamp: 'nice 1/5/2010 15:59'!
adjustSubmorphPositionsFrom: start to: stop
	"Fixed to not require setting item widths to 9999."
	
	| subs p |
	subs := scroller submorphs.
	p := (subs at: start) position.
	(start to: subs size) do: [:idx | | each h |
		each := subs at: idx.
		h := each height.
		each bounds: (p extent: each width@h).
		p := p + (0@h)].
! !

!LazyMorphTreeMorph methodsFor: 'lazy tree' stamp: 'AlainPlantec 11/19/2009 17:31'!
buildRowMorphsFrom: aNodeMorph
	self buildRowMorphsFrom: aNodeMorph increment: self lazyIncrement.
! !

!LazyMorphTreeMorph methodsFor: 'lazy tree' stamp: 'nice 1/5/2010 15:59'!
buildRowMorphsFrom: aNodeMorph increment: anIncrement
	
	Cursor wait 
		showWhile: [ | subs idx max |
			subs := scroller submorphs.
			idx :=  aNodeMorph index.
			max := (idx + anIncrement) min: subs size.
			self buildRowMorphsFromIndex: idx to: max].! !

!LazyMorphTreeMorph methodsFor: 'lazy tree' stamp: 'AlainPlantec 11/20/2009 08:26'!
buildRowMorphsFromIndex: startIndex to: stopIndex
	| controlWidths subs |
	subs := scroller submorphs.
	controlWidths := self controlWidths.
	(startIndex to: stopIndex) 
		do: [:p | (subs at: p) buildRowMorph; updateColumnMorphsWidthWith: controlWidths].
	self setScrollDeltas.
	self adjustSubmorphPositionsFrom: startIndex to: stopIndex.
	self setScrollDeltas.
	(startIndex to: stopIndex) 
		do: [:pos | (subs at: pos) drawable: true].
! !

!LazyMorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/15/2009 21:57'!
indentingItemClass
	
	^ LazyMorphTreeNodeMorph! !

!LazyMorphTreeMorph methodsFor: 'lazy tree' stamp: 'AlainPlantec 11/19/2009 13:53'!
lazyIncrement
	^ lazyIncrement ifNil: [ lazyIncrement := 30 ]! !

!LazyMorphTreeMorph methodsFor: 'lazy tree' stamp: 'tg 11/16/2009 02:26'!
lazyIncrement: anInteger
	lazyIncrement := anInteger ! !

!MorphTreeMorph class methodsFor: 'instance creation' stamp: 'AlainPlantec 10/29/2009 16:11'!
on: anObject list: getListSel 
	^ self new
		on: anObject
		list: getListSel
! !

!MorphTreeMorph class methodsFor: 'instance creation' stamp: 'AlainPlantec 11/3/2009 16:34'!
on: anObject list: getListSel columns: aListOfColumns
	^ self new
		on: anObject
		list: getListSel
		columns: aListOfColumns! !

!MorphTreeMorph class methodsFor: 'instance creation' stamp: 'AlainPlantec 11/3/2009 12:49'!
on: anObject list: getListSel  multiSelection: multi
	^ self new
		on: anObject
		list: getListSel
		 multiSelection: multi
! !

!MorphTreeMorph class methodsFor: 'instance creation' stamp: 'AlainPlantec 11/3/2009 16:34'!
on: anObject list: getListSel  multiSelection: multi columns: aListOfColumns
	^ self new
		on: anObject
		list: getListSel
	 	multiSelection: multi
		columns: aListOfColumns! !

!MorphTreeMorph class methodsFor: 'instance creation' stamp: 'AlainPlantec 11/3/2009 12:36'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel
	^ self new on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel! !

!MorphTreeMorph class methodsFor: 'instance creation' stamp: 'AlainPlantec 11/3/2009 16:34'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel columns: aListOfColumns
	^ self new on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel columns: aListOfColumns! !

!MorphTreeMorph methodsFor: 'dropping/grabbing' stamp: 'alain.plantec 10/12/2009 23:25'!
acceptDroppingMorph: aMorph event: evt

	self model
		acceptDroppingMorph: aMorph
		event: evt
		inMorph: self.
	self resetPotentialDropMorph.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/12/2009 21:23'!
addColumn: aTreeColumn
	self addColumn: aTreeColumn afterIndex: self columns size! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/15/2009 21:03'!
addColumn: aTreeColumn afterIndex: aPosition
	aTreeColumn container: self.
	self columns add: aTreeColumn afterIndex: aPosition.
	self columnsChanged.
	self updateColumnMorphs.
	self list: self getList.

! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/18/2009 09:54'!
addColumnResizers
	columnResizers := self columnResizerFrames
				withIndexCollect: [:frm :idx | 
					(MorphTreeResizerMorph container: self index: idx) bounds: (frm translateBy: (scroller offset x negated @ 0))].
	self addAllMorphs: columnResizers.
	self columnResizersToFront! !

!MorphTreeMorph methodsFor: 'private' stamp: 'AlainPlantec 11/26/2009 08:01'!
addMorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean

	| priorMorph morphList newCollection |
	priorMorph := nil.
	newCollection := (sortBoolean and: [sortingSelector notNil]) ifTrue: [
		(aCollection asSortedCollection: [ :a :b | 
			(a perform: sortingSelector) <= (b perform: sortingSelector)]) asOrderedCollection
	] ifFalse: [
		aCollection
	].
	morphList := OrderedCollection new.
	newCollection do: [:item | 
		priorMorph := self indentingItemClass new 
			initWithContents: item 
			prior: priorMorph 
			forList: self
			indentLevel: parentMorph indentLevel + 1.
		morphList add: priorMorph.
	].
	morphList do: [:i |
		i
			extent: i minWidth @ i minHeight].
	scroller addAllMorphs: morphList after: parentMorph.
	self updateColumnMorphsWidth.

	^morphList
	
! !

!MorphTreeMorph methodsFor: 'private' stamp: 'AlainPlantec 11/15/2009 21:29'!
addMorphsTo: morphList from: aCollection allowSorting: sortBoolean withExpandedItems: expandedItems atLevel: newIndent

	| priorMorph newCollection firstAddition |
	priorMorph := nil.
	newCollection := (sortBoolean and: [sortingSelector notNil]) ifTrue: [
		(aCollection asSortedCollection: [ :a :b | 
			(a perform: sortingSelector) <= (b perform: sortingSelector)]) asOrderedCollection
	] ifFalse: [
		aCollection
	].
	firstAddition := nil.
	newCollection do: [:item | 
		priorMorph := self indentingItemClass new 
			initWithContents: item 
			prior: priorMorph 
			forList: self
			indentLevel: newIndent.
		firstAddition ifNil: [firstAddition := priorMorph].
		morphList add: priorMorph.
		((item hasEquivalentIn: expandedItems) or: [priorMorph isExpanded]) ifTrue: [
			priorMorph isExpanded: true.
			priorMorph 
				addChildrenForList: self 
				addingTo: morphList
				withExpandedItems: expandedItems.
		].
	].
	^firstAddition
	
! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/1/2009 06:28'!
addSelectedMorph: aNodeMorph
	self selectedMorphList add: aNodeMorph.
! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 10:52'!
addSelectedNodeItem: aNodeItem
	(self nodeMorphsWithNodeItem: aNodeItem) do: [:m | self selectedMorphList add: m].
	self selectionChanged.! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'nice 1/5/2010 15:59'!
adjustSubmorphPositions
	"Fixed to not require setting item widths to 9999."
	
	| p idx |
	p := 0@0.
	idx := 1.
	scroller submorphsDo: [ :each | | h |
		h := each height.
		each index: idx.
		each bounds: (p extent: each width@h).
		idx := idx + 1.
		p := p + (0@h)
	].
	self 
		changed;
		layoutChanged;
		updateColumnResizersHeight;
		setScrollDeltas
	! !

!MorphTreeMorph methodsFor: 'updating' stamp: 'AlainPlantec 10/29/2009 10:12'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self selectionColor: self selectionColor.
	self borderStyle baseColor: paneColor twiceDarker.
	self color: (self preferedPaneColor ifNil: [paneColor veryMuchLighter]).! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/30/2009 10:21'!
allNodes
	^ scroller submorphs
		! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/12/2009 21:25'!
allNodesDo: aBlock
	^ scroller submorphsDo: aBlock
		! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/14/2009 08:56'!
allowColumnDrop
	columnDropUnabled := true! !

!MorphTreeMorph methodsFor: 'updating' stamp: 'AlainPlantec 11/16/2009 13:29'!
arrange
	self columnsChanged.
	self updateColumnMorphs.
	self innerWidgetChanged.
	scroller submorphsDo: [:sm | sm layoutInset: self hCellInset @ self vCellInset].

! !

!MorphTreeMorph methodsFor: 'keyboard navigation' stamp: 'AlainPlantec 11/3/2009 21:34'!
arrowEvent: event key: aChar
	"Handle a keyboard navigation character. Answer true if handled, false if not."
     aChar = Character arrowDown ifTrue:["down"
		self setSelectionIndex: self getSelectionIndex+1 multiSelection: event shiftPressed.
		^true].
     aChar = Character arrowUp ifTrue:["up"
		self setSelectionIndex: (self getSelectionIndex-1 max: 1) multiSelection: event shiftPressed.
		^true].
     aChar = Character home ifTrue: ["home"
		self setSelectionIndex: 1 multiSelection: event shiftPressed.
		^true].
     aChar = Character end ifTrue: ["end"
		self setSelectionIndex: scroller submorphs size multiSelection: event shiftPressed.
		^true].
      aChar = Character pageUp ifTrue: ["page up"
		self setSelectionIndex: (self getSelectionIndex - self numSelectionsInView max: 1) multiSelection: event shiftPressed.
		^true].
     aChar = Character pageDown  ifTrue: ["page down"
		self setSelectionIndex: self getSelectionIndex + self numSelectionsInView multiSelection: event shiftPressed.
		^true].
	aChar = Character arrowRight ifTrue:["right"
		self selectedMorph ifNotNil:[
			(self selectedMorph canExpand and:[self selectedMorph isExpanded not])
				ifTrue:[self toggleExpandedState: self selectedMorph]
				ifFalse:[self setSelectionIndex: self getSelectionIndex+1 multiSelection: event shiftPressed].
		].
		^true].
	aChar = Character arrowLeft ifTrue:["left"
		self selectedMorph ifNotNil:[
			(self selectedMorph isExpanded)
				ifTrue:[self toggleExpandedState: self selectedMorph]
				ifFalse:[self setSelectionIndex: (self getSelectionIndex-1 max: 1) multiSelection: event shiftPressed].
		].
		^true].
	^false! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/1/2009 16:09'!
autoDeselect
	^ autoDeselect
		ifNil: [autoDeselect := false]! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'alain.plantec 10/12/2009 23:25'!
autoDeselect: trueOrFalse
	"Enable/disable autoDeselect (see class comment)"
	autoDeselect := trueOrFalse.! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/18/2009 07:29'!
beMultiple	
	allowsMultipleSelection := true! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/18/2009 07:30'!
beSingle	
	allowsMultipleSelection := false! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/25/2009 20:11'!
buildTopHeader
	| subs |
	subs := OrderedCollection new.
	self columns
		do: [:col |
			col container: self.
			subs add: (col header layoutInset: self hCellInset@0; yourself).
			subs last hResizing: #rigid].
	topHeader := Morph new fillStyle: self topHeaderBackground.
	self addMorph: topHeader.
	topHeader clipSubmorphs: true.
	topHeader borderColor: Color gray.
	topHeader color: Color transparent.
	topHeader borderWidth: 0.
	topHeader addAllMorphs: subs.
	topHeader bounds: ((scroller left) @ self top corner: (scroller right + 3) @ self top + self topHeaderHeight).

! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/15/2009 18:15'!
cellInset: anIntegerOrAPoint
	| inset |
	inset := anIntegerOrAPoint isPoint ifTrue: [anIntegerOrAPoint] ifFalse: [anIntegerOrAPoint @ anIntegerOrAPoint].
	hCellInset := inset x.
	vCellInset := inset y.
	
! !

!MorphTreeMorph methodsFor: 'enumeration' stamp: 'alain.plantec 10/24/2009 23:08'!
childrenDo: aBlock
	self roots do: aBlock! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/17/2009 19:47'!
columnColorForEven: evenColor 
	columnColors at: 2 put: nil.
	columnColors at: 1 put: evenColor.
	! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/17/2009 19:47'!
columnColorForEven: evenColor odd: oddColor
	columnColors at: 2 put: oddColor.
	columnColors at: 1 put: evenColor.
	! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/17/2009 19:47'!
columnColorForOdd: oddColor 
	columnColors at: 1 put: nil.
	columnColors at: 2 put: oddColor.
	! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2009 19:40'!
columnColors 
	^ columnColors ! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/14/2009 08:59'!
columnDropUnabled
	^ columnDropUnabled ifNil: [columnDropUnabled := true]! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/18/2009 09:54'!
columnResizerFrames
	| xOffset frms |
	xOffset := 0.
	frms := self columns collect: [:col | 
		xOffset := self minResizerOffset max: (xOffset + col currentWidth).
		scroller left + xOffset @ self top corner: scroller left + xOffset + self resizerWidth @ scroller bottom].
	self lastColumnUnbounded  
		ifTrue: [frms 
			ifNotEmpty: [frms removeLast]].
	^ frms collect: [:f | f translateBy: (scroller offset x negated @ 0)]! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'tg 11/9/2009 16:57'!
columnResizers
	^ columnResizers ifNil: [ columnResizers := OrderedCollection new ]! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/12/2009 14:48'!
columnResizersToFront
	self columnResizers do: [:cl | cl comeToFront; fillStyle: cl normalFillStyle].
! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/3/2009 21:24'!
columns

	^columns ifNil: [columns := #()]! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/10/2009 07:15'!
columns: aListOfTreeColumn

	columns := aListOfTreeColumn asOrderedCollection.
	aListOfTreeColumn do: [:col | col container: self].
	self buildTopHeader .
	self addColumnResizers.
! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/12/2009 15:26'!
columnsChanged
	self removeColumnResizers.
	self removeTopHeader.
	self buildTopHeader.
	self addColumnResizers.
! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/1/2009 22:28'!
commandOrCrontrolKeyPressed: anEvent
	^ (OSPlatform current platformFamily ~= #MacOSX) 
		ifTrue: [anEvent controlKeyPressed]
		ifFalse: [anEvent commandKeyPressed]! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/17/2009 13:50'!
controlWidths
	| result |
	result :=  self headerBounds collect: [:b | b width - (2 * self hCellInset) - 3].
	result ifNotEmpty: [result at: 1 put: ((result at: 1) - 0)].
	^ result
! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'alain.plantec 10/12/2009 23:25'!
currentlyExpanded

	^(scroller submorphs select: [ :each | each isExpanded]) collect: [ :each |
		each complexContents
	].
	! !

!MorphTreeMorph methodsFor: 'submorphs-add/remove' stamp: 'AlainPlantec 11/27/2009 22:51'!
delete
	super delete.
! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 12/1/2009 16:10'!
doubleClick: anEvent 
	doubleClickSelector isNil
		ifTrue: [^ super doubleClick: anEvent].
	self model perform: doubleClickSelector ! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 12/1/2009 16:05'!
doubleClickSelector: aSelector
	doubleClickSelector := aSelector! !

!MorphTreeMorph methodsFor: 'drawing' stamp: 'nice 1/5/2010 15:59'!
drawLinesOn: aCanvas
	"Draw the lines for the submorphs.
	Modified for performance."
	
	| lColor|
	lColor := self lineColor.
	aCanvas 
		transformBy: scroller transform
		clippingTo: scroller innerBounds
		during: [:clippedCanvas |
			scroller submorphsDo: [ :submorph | | last |
				((submorph isExpanded and: [
					(submorph nextSibling notNil and: [
						clippedCanvas isVisible: (submorph fullBounds topLeft
							corner: submorph nextSibling fullBounds bottomRight)]) or: [
					submorph nextSibling isNil and: [(last := submorph lastChild) notNil and: [
						clippedCanvas isVisible: (submorph fullBounds topLeft
							corner: last fullBounds bottomRight)]]]]) or: [
				(clippedCanvas isVisible: submorph fullBounds) or: [
				(submorph nextSibling notNil and: [
						clippedCanvas isVisible: submorph nextSibling fullBounds])]]) ifTrue:[
					submorph drawLinesOn: clippedCanvas lineColor: lColor]]]
		smoothing: scroller smoothing
! !

!MorphTreeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 12/10/2009 17:38'!
drawOn: aCanvas
	"Draw the selection and lines."
	super drawOn: aCanvas.
	self columns do: [:col | col drawColumnOn: aCanvas].
	aCanvas clipBy: self innerBounds during: [:c |
		self selectedMorphList do: [:it | | selectionFrame |
			selectionFrame := self selectionFrameFor: it.
			(c isVisible: selectionFrame) ifTrue: [
				c
					fillRectangle: selectionFrame
					color: self selectionColorToUse]]].
	
! !

!MorphTreeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 12/10/2009 17:37'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas].
! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 13:26'!
emptySelection 
	self emptySelectionSilently.
	self changed
! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 13:26'!
emptySelectionSilently
	self unhighlightSelection.
	selectedMorphList removeAll.
! !

!MorphTreeMorph methodsFor: 'events' stamp: 'alain.plantec 10/12/2009 23:25'!
expand: aMorph to: level
	| allChildren |
	aMorph toggleExpandedState.
	allChildren := OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		((each canExpand
			and: [each isExpanded not])
			and: [level > 0])
			ifTrue: [self expand: each to: level-1]].! !

!MorphTreeMorph methodsFor: 'updating' stamp: 'AlainPlantec 11/9/2009 17:55'!
expandAll
	"Expand all of the roots!!"
	
	self roots do: [:m | self expandAll: m].
	self innerWidgetChanged! !

!MorphTreeMorph methodsFor: 'events' stamp: 'alain.plantec 10/12/2009 23:25'!
expandAll: aMorph
	| allChildren |
	aMorph toggleExpandedState.
	allChildren := OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		(each canExpand and: [each isExpanded not])
			ifTrue: [self expandAll: each]].
! !

!MorphTreeMorph methodsFor: 'events' stamp: 'alain.plantec 10/12/2009 23:25'!
expandAll: aMorph except: aBlock
	| allChildren |
	(aBlock value: aMorph complexContents)
		ifFalse: [^self].
	aMorph toggleExpandedState.
	allChildren := OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		(each canExpand
			and: [each isExpanded not])
			ifTrue: [self expandAll: each except: aBlock]].! !

!MorphTreeMorph methodsFor: 'events' stamp: 'AlainPlantec 11/9/2009 17:55'!
expandRoots
	"Expand all the receiver's roots"
	self roots
		do: [:each |
			(each canExpand and: [each isExpanded not])
				ifTrue: [each toggleExpandedState]].
	self innerWidgetChanged! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'alain.plantec 10/12/2009 23:25'!
expandedForm
	"Answer the form to use for expanded items."
	
	^self theme treeExpandedForm! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:07'!
expandedToggleImage
	^ expandedToggleImage ifNil: [expandedToggleImage := ImageMorph new image: self expandedForm].
! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/26/2009 09:08'!
extent: newExtent
	bounds extent = newExtent ifTrue: [^ self].
	super extent: newExtent.
	self resizerChanged.
! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 13:59'!
firstChild
	^ scroller submorphs ifNotEmpty: [scroller submorphs at: 1]! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/14/2009 08:57'!
forbidColumnDrop
	columnDropUnabled := false! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 10/29/2009 10:07'!
gapAfterIcon
	^ gapAfterIcon ifNil: [gapAfterIcon := 4]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/15/2009 18:15'!
gapAfterIcon: anInteger
	gapAfterIcon := anInteger.
! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 10/29/2009 10:07'!
gapAfterToggle
	^ gapAfterToggle ifNil: [gapAfterToggle := 5]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/15/2009 18:16'!
gapAfterToggle: anInteger
	gapAfterToggle := anInteger.
! !

!MorphTreeMorph methodsFor: 'geometry constants' stamp: 'alain.plantec 3/10/2009 13:24'!
gapBetweenToggleAndIcon
	^ 4! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 08:04'!
getCurrentSelectionIndex
	lastSelectedMorph ifNil: [^ 0].
	^ self getSelectionIndexOf: lastSelectedMorph! !

!MorphTreeMorph methodsFor: 'model access' stamp: 'AlainPlantec 11/1/2009 17:50'!
getList 
	"Answer the list to be displayed."

	^ model perform: self getListSelector

! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/1/2009 17:49'!
getListSelector
	^ getListSelector ifNil: [getListSelector := #roots]! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/1/2009 18:09'!
getListSelector: aSelector
	getListSelector := getListSelector.
	self update: getListSelector.! !

!MorphTreeMorph methodsFor: 'keyboard navigation' stamp: 'AlainPlantec 11/1/2009 16:36'!
getSelectionIndex
	^ self getSelectionIndexOf: self selectedMorph! !

!MorphTreeMorph methodsFor: 'keyboard navigation' stamp: 'AlainPlantec 1/11/2010 13:45'!
getSelectionIndexOf: aMorph
	^ aMorph ifNil: [0] ifNotNil: [aMorph index]! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/19/2009 13:45'!
getSelectionSelector
	^ getSelectionSelector ifNil: [getSelectionSelector := #selection]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'alain.plantec 10/23/2009 09:02'!
hCellInset
	^ hCellInset ifNil: [hCellInset := 0]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/15/2009 18:15'!
hCellInset: anInteger
	hCellInset := anInteger.
! !

!MorphTreeMorph methodsFor: 'scrolling' stamp: 'AlainPlantec 11/14/2009 09:28'!
hExtraScrollRange
	"Return the amount of extra blank space to include below the bottom of the scroll content."
	^ 10
! !

!MorphTreeMorph methodsFor: 'scrolling' stamp: 'AlainPlantec 11/15/2009 14:49'!
hScrollBarValue: scrollValue
	super hScrollBarValue: scrollValue.
	self updateColumnResizersXOffset.
	self updateTopHeader ! !

!MorphTreeMorph methodsFor: 'events-processing' stamp: 'alain.plantec 10/12/2009 23:25'!
handleMouseMove: anEvent
	"Reimplemented because we really want #mouseMove when a morph is dragged around"
	anEvent wasHandled ifTrue:[^self]. "not interested"
	(anEvent anyButtonPressed and:[anEvent hand mouseFocus == self]) ifFalse:[^self].
	anEvent wasHandled: true.
	self mouseMove: anEvent.
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'alain.plantec 10/12/2009 23:25'!
handlesKeyboard: evt
	^true! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'alain.plantec 10/12/2009 23:25'!
handlesMouseOverDragging: evt
	^self dropEnabled! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:07'!
hasToggleAtRoot
	^ hasToggleAtRoot ifNil: [hasToggleAtRoot := self roots anySatisfy: [:s | s hasToggle]]
! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/12/2009 21:20'!
haveRowMorphAfterIndex: anIndex
	self childrenDo: [:c | 
		c controls size > anIndex 
			ifTrue: [^ true]].
	^ false! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'nice 1/5/2010 15:59'!
headerBounds
	| positions controlBounds currPos currLeft |
	controlBounds := OrderedCollection new.
	currPos := scroller left - 3.
	(positions := self columnResizers asOrderedCollection collect: [:r | r position])
		ifNotEmpty: [ | currRight |
			currPos := positions removeFirst x.
			currLeft :=  scroller left - scroller offset x - 3.
			currRight := currPos.
			controlBounds add: (currLeft @ topHeader top corner: currRight @ topHeader bottom).
			[positions notEmpty] whileTrue: [
				currLeft := currPos + self resizerWidth .
				currPos := positions removeFirst x.
				currRight := currPos.
				controlBounds add: (currLeft @ topHeader top corner: currRight @ topHeader bottom)].
			].
	self columnResizers size < self columns size ifTrue: [
		currLeft := currPos + self resizerWidth .
		controlBounds add: (currLeft @ topHeader top corner: (scroller right) @ topHeader bottom)].
	^ controlBounds 
	
! !

!MorphTreeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/26/2009 07:46'!
highlightSelection
	self selectedMorphList do: [:it | it highlight]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/14/2009 09:15'!
iconReservedExtent
	^ iconReservedExtent ifNil: [iconReservedExtent := 0 @ 0]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/14/2009 09:26'!
iconReservedExtent: anExtent
	anExtent > self iconReservedExtent 
		ifTrue: [iconReservedExtent := anExtent]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 10/29/2009 10:07'!
indentGap
	^ indentGap ifNil: [indentGap := 20]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/15/2009 18:16'!
indentGap: anInteger
	indentGap := anInteger.
! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/15/2009 21:58'!
indentingItemClass
	
	^ MorphTreeNodeMorph! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/26/2009 08:29'!
initialize
	"initialize the state of the receiver"
	super initialize.
	selectedMorphList := OrderedCollection new.
	columnColors := Array new: 2.
	rowColors := Array new: 2.
	self
		on: #mouseMove
		send: #mouseStillDown:onItem:
		to: self.
	self borderWidth: 1.
	
! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 12/17/2009 21:39'!
initializeScrollBars
"initialize the receiver's scrollBar"

	(scrollBar := ScrollBar new model: self slotName: 'vScrollBar')
			borderWidth: 1; 
			borderColor: Color black.
	(hScrollBar := ScrollBar new model: self slotName: 'hScrollBar')
			borderWidth: 1; 
			borderColor: Color black.

	""
	scroller := MorphTreeTransformMorph new color: Color transparent.
	scroller offset: -3 @ 0.
	self addMorph: scroller.
	""
	scrollBar initializeEmbedded: retractableScrollBar not.
	hScrollBar initializeEmbedded: retractableScrollBar not.
	retractableScrollBar ifFalse: 
			[self 
				addMorph: scrollBar;
				addMorph: hScrollBar].

	self alwaysShowVScrollbar ifTrue:
		[ self alwaysShowVScrollBar: true ].
		
	self alwaysHideHScrollbar
		ifTrue:[self hideHScrollBarIndefinitely: true ]
		ifFalse:
			[self alwaysShowHScrollbar ifTrue:
				[ self alwaysShowHScrollBar: true ]].
! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/25/2009 20:26'!
innerBounds
	| inner |
	inner := super innerBounds.
	inner := inner withTop: self top + self topHeaderHeight + 3.
	^ inner
	! !

!MorphTreeMorph methodsFor: 'updating' stamp: 'AlainPlantec 11/11/2009 10:12'!
innerWidgetChanged
	self setScrollDeltas.
	self adjustSubmorphPositions.
! !

!MorphTreeMorph methodsFor: 'private' stamp: 'AlainPlantec 11/15/2009 12:55'!
insertNewMorphs: morphList
	"morphList do: [:m | m extent: m minWidth @ m minHeight]."
	scroller addAllMorphs: morphList.
	self innerWidgetChanged.
! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/18/2009 07:29'!
isMultiple	
	^ allowsMultipleSelection ifNil: [ allowsMultipleSelection := false ]! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/18/2009 07:29'!
isSingle	
	^ self isMultiple not! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/14/2009 09:31'!
keyStroke: event 
	"Process potential command keys.
	Fix for command key required (like PluggableListMorph)."

	| aCharacter args |
	(self navigationKey: event) ifTrue: [^true].
	(self scrollByKeyboard: event) ifTrue: [^self].
	aCharacter := event keyValue asCharacter. 
	"since ctrl-a, for instance, will have keyCharacter of 0 ascii with keyboard event and not $a as before Unicode refactoring"
	(self arrowEvent: event key: aCharacter) ifTrue: [^true].
	event anyModifierKeyPressed ifFalse: [^false].
	self keystrokeActionSelector ifNil: [^ false].
	args := self keystrokeActionSelector numArgs.
	(args = 0 or: [args > 2]) 
		ifTrue: [^ self error: 'The keystrokeActionSelector must be a 1- or 2-keyword symbol']
		ifFalse: [
			args = 1 
				ifTrue: [^ model perform: self keystrokeActionSelector with: aCharacter]
				ifFalse: [^ model 
					perform: self keystrokeActionSelector
					with: aCharacter 
					with: self]]! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'alain.plantec 10/12/2009 23:25'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self focusChanged! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/1/2009 18:11'!
keystrokeActionSelector
	^ keystrokeActionSelector ! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/1/2009 18:11'!
keystrokeActionSelector: aSelector
	keystrokeActionSelector := aSelector! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/11/2009 16:18'!
lastColumnBounded
	^ self lastColumnUnbounded not! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/14/2009 06:38'!
lastColumnUnbounded
	^ unboundLastColumn ifNil: [unboundLastColumn := true]! !

!MorphTreeMorph methodsFor: 'private' stamp: 'alain.plantec 3/9/2009 10:33'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Update the scroller and scrollbars now since bounds set directly
	(not via #extent:)."
	
	super layoutBounds: aRectangle.
	self
		resizeScroller;
		setScrollDeltas! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/14/2009 09:14'!
leftGap
	^self toggleImageWidth + self gapAfterToggle + self iconReservedExtent x + self gapAfterIcon.
! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'alain.plantec 10/12/2009 23:25'!
lineColor
	"Answer a good color to use for drawing the lines that connect members of the hierarchy view.
	Used the cached color, or derive it if necessary by finding the receiver or the first owner (up to my root) that is not transparent, then picking a contrasting color.
	Fall back to black if all my owners are transparent."

	| colored |
	lineColor ifNotNil: [^lineColor ].
	colored := self color isTransparent
		ifTrue: [self firstOwnerSuchThat: [:o | o isWorldOrHandMorph not and: [o color isTransparent not]]]
		ifFalse: [self].
	colored ifNil: [^Color black].
	^colored color luminance > 0.5
		ifTrue: [Color black]
		ifFalse: [Color white]
	
! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'alain.plantec 10/12/2009 23:25'!
lineColor: aColor
	^lineColor := aColor
! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/20/2009 20:51'!
list: aCollection

	| wereExpanded morphList |
	wereExpanded := self currentlyExpanded.
	scroller removeAllMorphs.
	(aCollection isNil or: [aCollection isEmpty]) ifTrue: [^ self emptySelection].
	morphList := OrderedCollection new.
	self 
		addMorphsTo: morphList
		from: aCollection 
		allowSorting: false
		withExpandedItems: wereExpanded
		atLevel: 0.
	self insertNewMorphs: morphList.
	self updateSelectionFromModel.
	self roots do: [:r | r updateChildrenRecursively].
	self innerWidgetChanged.
	! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/14/2009 06:51'!
makeLastColumnBounded
	self lastColumnBounded 
		ifFalse: [
			unboundLastColumn := false.
			self columnsChanged.
			self list: self getList]
! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/15/2009 18:12'!
makeLastColumnUnbounded
	unboundLastColumn := true

! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'alain.plantec 10/12/2009 23:25'!
maximumSelection

	^ scroller submorphs size
! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/3/2009 17:29'!
minResizerOffset
	^ 20! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/17/2009 16:25'!
minResizerX
	^ scroller left + self minResizerOffset! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'alain.plantec 10/12/2009 23:25'!
minimumSelection
	^ 1! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 12/1/2009 16:13'!
mouseDown: evt 
	"Changed to take keybaord focus."
	| aMorph selectors | 
	self wantsKeyboardFocus
		ifTrue: [self takeKeyboardFocus].
	evt yellowButtonPressed
		ifTrue: ["First check for option (menu) click"
			^ self yellowButtonEvent: evt].
	(aMorph := self scrollerSubMorphFromPoint: evt position)
		ifNotNil: [aMorph hasToggle
				ifTrue: [(aMorph
							inToggleArea: (aMorph point: evt position from: self))
						ifTrue: [^ self toggleExpandedState: aMorph event: evt]]].
	aMorph
		ifNil: [^ super mouseDown: evt].
	aMorph highlightForMouseDown.
	selectors := Array
				with: #click:
				with: #doubleClick:
				with: nil
				with: (self dragEnabled
						ifTrue: [#startDrag:]).
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: selectors
		threshold: 10! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'alain.plantec 10/12/2009 23:25'!
mouseDownHighlightColor
	"Answer a good color to use for drawing the mouse down highlight.
	Used the line color if not transparent, otherwise a contrasting color in the
	same way as the line color is determined.
	Fall back to black if all my owners are transparent."

	|c colored |
	c := self lineColor.
	c isTransparent ifFalse: [^c].
	colored := self color isTransparent
		ifTrue: [self firstOwnerSuchThat: [:o | o isWorldOrHandMorph not and: [o color isTransparent not]]]
		ifFalse: [self].
	colored ifNil: [^Color black].
	^colored color luminance > 0.5
		ifTrue: [Color black]
		ifFalse: [Color white]
! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 12/10/2009 14:30'!
mouseEnter: event
	"Changed to take keyboardFocusOnMouseDown preference into account."
	
	super mouseEnter: event.
	self wantsKeyboardFocus ifFalse: [^self].
	self keyboardFocusOnMouseDown
		ifFalse: [self takeKeyboardFocus]! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/26/2009 07:37'!
mouseEnterDragging: evt
	| aMorph |
	(evt hand hasSubmorphs and:[self dropEnabled]) ifFalse: ["no d&d"
		^super mouseEnterDragging: evt].
	(self wantsDroppedMorph: evt hand firstSubmorph event: evt )
		ifTrue:[
			aMorph := self scrollerSubMorphFromPoint: evt position.
			aMorph ifNotNil:[self potentialDropMorph: aMorph].
			evt hand newMouseFocus: self.
			"above is ugly but necessary for now"
		].! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'alain.plantec 10/12/2009 23:25'!
mouseLeaveDragging: anEvent
	(self dropEnabled and:[anEvent hand hasSubmorphs]) ifFalse: ["no d&d"
		^ super mouseLeaveDragging: anEvent].
	self resetPotentialDropMorph.
	anEvent hand releaseMouseFocus: self.
	"above is ugly but necessary for now"
! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/26/2009 07:37'!
mouseMove: evt

	|aMorph|
	aMorph := self scrollerSubMorphFromPoint: evt position.
	evt hand hasSubmorphs ifFalse: [
		(aMorph isNil or: [aMorph highlightedForMouseDown not])
			ifTrue: [scroller submorphsDo: [:m |
					m highlightedForMouseDown ifTrue: [m highlightForMouseDown: false]].
					aMorph ifNotNil: [aMorph highlightForMouseDown]]].
	(self dropEnabled and:[evt hand hasSubmorphs]) 
		ifFalse:[^super mouseMove: evt].
	potentialDropMorph ifNotNil:[
		(potentialDropMorph containsPoint: (potentialDropMorph point: evt position from: self))
			ifTrue:[^self].
	].
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) 
		ifTrue:[self mouseEnterDragging: evt].! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/26/2009 09:45'!
mouseUp: event 
	"Fixed up highlight problems."
	| nodeMorph wasHigh|
	nodeMorph := self scrollerSubMorphFromPoint: event position.
	wasHigh := nodeMorph notNil ifTrue: [nodeMorph highlightedForMouseDown] ifFalse: [false].
	scroller submorphsDo: [:m |
		m highlightedForMouseDown ifTrue: [m highlightForMouseDown: false]].
	wasHigh ifFalse: [nodeMorph ifNotNil: [^self]].
	model okToChange ifFalse: [^self].
	"No change if model is locked" 
	self mouseUp: event onMorph: nodeMorph.
	! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 1/11/2010 13:38'!
mouseUp: event onMorph: aNodeMorph
	| path selHolder |
	self selectionChanged.
	path := event shiftPressed 
		ifTrue: [self shiftSelectMorph: aNodeMorph]
		ifFalse: [self selectMorph: aNodeMorph multiple: (self commandOrCrontrolKeyPressed: event)].
	selHolder := self newSelectionHolderWithNodePath: path.
	self emptySelectionSilently.
	model perform: self setSelectionSelector with: selHolder.
	self highlightSelection.
	Cursor normal show ! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 07:55'!
newSelectionHolderWithNodePath: aNodePath
	^ self isMultiple 
		ifTrue: [MorphTreeMorphMultipleSelection new selectedNodePathList: (self selectedMorphList collect: [:s | s path collect: [:m | m complexContents]])]
		ifFalse: [MorphTreeMorphSingleSelection new selectedNodePath: aNodePath]! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/1/2009 06:58'!
nodeMorphsWithAllNodeItems: aNodeItemList
	^ scroller submorphs select: [:m | aNodeItemList includes: m complexContents withoutListWrapper]! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 10:53'!
nodeMorphsWithNodeItem: aNodeItem
	^ scroller submorphs select: [:m | m complexContents withoutListWrapper = aNodeItem]! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'alain.plantec 10/12/2009 23:25'!
notExpandedForm
	"Answer the form to use for unexpanded items."
	
	^self theme treeUnexpandedForm! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:08'!
notExpandedToggleImage
	^ notExpandedToggleImage ifNil: [notExpandedToggleImage := ImageMorph new image: self notExpandedForm].
! !

!MorphTreeMorph methodsFor: 'private' stamp: 'AlainPlantec 11/26/2009 07:47'!
noteRemovalOfAll: aCollection

	scroller removeAllMorphsIn: aCollection.
	aCollection do: [:n | self selectedMorphList remove: n ifAbsent: []]
! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/3/2009 12:45'!
on: anObject list: getListSel 

	self  on: anObject list: getListSel multiSelection: false! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/3/2009 16:36'!
on: anObject list: getListSel columns: aListOfColumns

	self columns: aListOfColumns.
	self on: anObject list: getListSel multiSelection: false.

! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/19/2009 13:45'!
on: anObject list: getListSel multiSelection: isMulti

	self model: anObject.
	getListSelector := getListSel.
	allowsMultipleSelection := isMulti.
	self list: self getList.! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/18/2009 07:33'!
on: anObject list: getListSel multiSelection: isMulti columns: aListOfColumns

	self columns: aListOfColumns.
	self on: anObject list: getListSel multiSelection: isMulti

! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/3/2009 12:30'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel

	self model: anObject.
	getListSelector := getListSel.
	getSelectionSelector := getSelectionSel.
	setSelectionSelector := setSelectionSel.
	getMenuSelector := getMenuSel.
	keystrokeActionSelector := keyActionSel.
	self list: self getList.! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/3/2009 16:35'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel columns: aListOfColumns

	self columns: aListOfColumns.
	self on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel

! !

!MorphTreeMorph methodsFor: 'dropping/grabbing' stamp: 'alain.plantec 10/12/2009 23:25'!
potentialDropMorph
	^potentialDropMorph! !

!MorphTreeMorph methodsFor: 'dropping/grabbing' stamp: 'alain.plantec 10/12/2009 23:25'!
potentialDropMorph: aMorph
	potentialDropMorph := aMorph.
	aMorph highlightForDrop! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:08'!
preferedPaneColor
	^ preferedPaneColor! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:08'!
preferedPaneColor: aColor
	self color: (preferedPaneColor := aColor).
! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/27/2009 22:52'!
release
	selectedMorphList := nil.
	lastSelectedMorph := nil.
	columns ifNotNil: [columns do: [:col | col release]. columns := nil].
	potentialDropMorph := nil.
	lineColor := nil.
	columnResizers := nil.
	preferedPaneColor := nil.
	expandedToggleImage := nil.
	notExpandedToggleImage := nil.
	super release.! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/12/2009 21:24'!
removeColumn: aTreeColumn
	self removeColumnAtIndex: (self columns indexOf: aTreeColumn)! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/15/2009 21:02'!
removeColumnAtIndex: aPosition.
	self columns removeAt: aPosition.
	self columnsChanged.
	self updateColumnMorphs.
	self list: self getList.




! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/10/2009 07:22'!
removeColumnResizers.
	self removeAllMorphsIn: self columnResizers.
	self columnResizers do: [:r | r release].
	self columnResizers removeAll! !

!MorphTreeMorph methodsFor: 'initialize - release' stamp: 'AlainPlantec 11/15/2009 18:02'!
removeTopHeader
	topHeader 
		ifNotNil: [self removeMorph: topHeader.
		topHeader := nil]
! !

!MorphTreeMorph methodsFor: 'dropping/grabbing' stamp: 'alain.plantec 10/12/2009 23:25'!
resetPotentialDropMorph
	potentialDropMorph ifNotNil: [
		potentialDropMorph resetHighlightForDrop.
		potentialDropMorph := nil]
! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:08'!
resetRootInfo
	hasToggleAtRoot := nil.! !

!MorphTreeMorph methodsFor: 'updating' stamp: 'AlainPlantec 11/15/2009 17:28'!
resizerChanged
	self updateColumnResizersXOffset;
		resizeScroller;
		updateColumnMorphs! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 10/29/2009 10:08'!
resizerWidth
	^ resizerWidth ifNil:[resizerWidth := 5]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/15/2009 18:16'!
resizerWidth: anInteger
	resizerWidth := anInteger.
! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'alain.plantec 10/12/2009 23:25'!
roots
	"Answer the receiver's roots"
	^ scroller submorphs
		select: [:each | each indentLevel isZero]! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/20/2009 16:51'!
rowColorForEven: evenColor 
	rowColors at: 2 put: nil.
	rowColors at: 1 put: evenColor.
	! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/20/2009 16:51'!
rowColorForEven: evenColor odd: oddColor
	rowColors at: 2 put: oddColor.
	rowColors at: 1 put: evenColor.
	! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/20/2009 16:52'!
rowColorForOdd: oddColor 
	rowColors at: 1 put: nil.
	rowColors at: 2 put: oddColor.
	! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/20/2009 16:59'!
rowColors
	^ rowColors! !

!MorphTreeMorph methodsFor: 'scrolling' stamp: 'AlainPlantec 10/29/2009 11:08'!
scrollDeltaHeight
	^ scrollDeltaHeight ifNil: [scrollDeltaHeight := 20]! !

!MorphTreeMorph methodsFor: 'scrolling' stamp: 'AlainPlantec 10/29/2009 11:09'!
scrollDeltaHeight: anInteger
	scrollDeltaHeight := anInteger! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/14/2009 09:06'!
scrollDeltaWidth
	"A guess -- assume that the width of a char is approx 1/2 the height of the font"
	^ self scrollDeltaHeight // 2


! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 08:04'!
scrollSelectionIntoView
	"make sure that the current selection is visible"
	lastSelectedMorph ifNil: [^ self].
	self scrollToShow: lastSelectedMorph bounds! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/26/2009 07:36'!
scrollerSubMorphFromPoint: aPoint
	"Return the list element (morph) at the given point or nil if outside"
	| ptY |
	scroller hasSubmorphs ifFalse:[^nil].
	(scroller fullBounds containsPoint: aPoint) ifFalse:[^nil].
	ptY := (scroller firstSubmorph point: aPoint from: self) y.
	"note: following assumes that submorphs are vertical, non-overlapping, and ordered"
	scroller firstSubmorph top > ptY ifTrue:[^nil].
	scroller lastSubmorph bottom < ptY ifTrue:[^nil].
	"now use binary search"
	^scroller 
		findSubmorphBinary:[:item|
			(item top <= ptY and:[item bottom >= ptY])
				ifTrue:[0] "found"
				ifFalse:[ (item top + item bottom // 2) > ptY ifTrue:[-1] ifFalse:[1]]]! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 07:46'!
selectFrom: idx1 to: idx2
	(idx1 to: idx2) do: [:i | selectedMorphList add: (scroller submorphs at: i)].! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/1/2009 16:08'!
selectMorph: aNodeMorph multiple: multipleSelection 
	| path mult |
	aNodeMorph isNil
		ifTrue: [self emptySelection.
			path := nil]
		ifFalse: [(self selectedMorphList includes: aNodeMorph)
				ifTrue: [multipleSelection
						ifTrue: [self selectedMorphList remove: aNodeMorph]
						ifFalse: [mult := self selectedMorphList size > 1.
							path := aNodeMorph path
										collect: [:m | m complexContents].
							(self autoDeselect 
									or: [mult])
								ifTrue: [self emptySelection.
									mult
										ifTrue: [self selectedMorphList add: aNodeMorph]
										ifFalse: [path := nil]]]]
				ifFalse: [multipleSelection
						ifFalse: [self selectedMorphList removeAll].
					self selectedMorphList add: aNodeMorph.
					path := aNodeMorph path
								collect: [:m | m complexContents]]].
	lastSelectedMorph := aNodeMorph.
	^ path! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 07:20'!
selectNodePath: aPath
	aPath 
		ifNil: [self emptySelection] 
		ifNotNil: [self firstChild 
			ifNotNil: [:fc | fc selectNodePath: aPath]]! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 1/11/2010 13:43'!
selectedMorph
	^ selectedMorphList ifEmpty: [nil] ifNotEmpty: [selectedMorphList last]! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 07:45'!
selectedMorphList
	^ selectedMorphList ifNil: [OrderedCollection new]! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/1/2009 06:42'!
selectionChanged
	"Invalidate frame of the current selection if any."
	self changed
	"self selectedMorphList do: [:it | self invalidRect: (self selectionFrameFor: it)]"! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 1/11/2010 14:01'!
selectionColor
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColor ifAbsent: [self theme settings selectionColor] ! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/14/2009 14:28'!
selectionColor: aColor
	"Set the colour for selected items."

	|w|
	aColor
		ifNil: [self removeProperty: #selectionColor]
		ifNotNil: [self setProperty: #selectionColor toValue: aColor].
	w := self ownerThatIsA: SystemWindow.
	self selectionColorToUse: (
		(self theme settings fadedBackgroundWindows not or: [w isNil or: [w isActive]])
			ifTrue: [aColor]
			ifFalse: [aColor  muchLighter])! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/18/2009 22:20'!
selectionColorToUse
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColorToUse 
		ifAbsent: [self theme settings selectionColor] ! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'alain.plantec 10/16/2009 15:54'!
selectionColorToUse: aColor
	"Set the colour for selected items."

	aColor = self selectionColorToUse ifTrue: [^self].
	aColor
		ifNil: [self removeProperty: #selectionColorToUse]
		ifNotNil: [self setProperty: #selectionColorToUse toValue: aColor].
	self selectionChanged ! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/25/2009 09:27'!
selectionFrameFor: aNodeMorph
	"Answer the frame of aNodeMorph in the receiver"
	^ aNodeMorph bounds:  aNodeMorph selectionFrame in: self! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/20/2009 00:02'!
setScrollDeltas
	super setScrollDeltas.
	"self updateTopHeader"! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 08:04'!
setSelectedMorph: aMorph
	| path selHolder |
	path := aMorph ifNotNil: [aMorph path collect: [:m | m complexContents]].
	lastSelectedMorph := aMorph.
	self selectedMorphList removeAll.
	self selectedMorphList add: lastSelectedMorph.
	selHolder := self newSelectionHolderWithNodePath: path.
	model perform: self setSelectionSelector with: selHolder.
! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 10:56'!
setSelectedNodeItem: aNodeItem
	self selectedMorphList removeAll.
	self addSelectedNodeItem: aNodeItem! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/1/2009 07:08'!
setSelectedNodeItemList: aNodeItemCollection
	| keptSelectedMorphList |
	self selectedMorphList removeAll.
	"Don't work directly with selectedMorphList because for very long list, #drawOn: is time consuming"
	keptSelectedMorphList  := selectedMorphList.
	selectedMorphList := #().
	keptSelectedMorphList  addAll: (self nodeMorphsWithAllNodeItems: aNodeItemCollection).
	selectedMorphList := keptSelectedMorphList.
	self selectionChanged.! !

!MorphTreeMorph methodsFor: 'keyboard navigation' stamp: 'AlainPlantec 11/2/2009 18:05'!
setSelectionIndex: idx
	"Called internally to select the index-th item."
	| theMorph index |
	idx ifNil: [^ self].
	index := idx min: scroller submorphs size max: 0.
	theMorph := index = 0 ifTrue: [nil] ifFalse: [scroller submorphs at: index].
	self setSelectedMorph: theMorph.
	self scrollSelectionIntoView! !

!MorphTreeMorph methodsFor: 'keyboard navigation' stamp: 'AlainPlantec 11/26/2009 07:52'!
setSelectionIndex: idx multiSelection: multiSelect
	"Called internally to select the index-th item."
	| theMorph index |
	idx ifNil: [^ self].
	index := idx min: scroller submorphs size max: 0.
	theMorph := index = 0 ifTrue: [nil] ifFalse: [scroller submorphs at: index].
	multiSelect 
		ifTrue: [self shiftSelectMorph: theMorph]
		ifFalse: [self setSelectedMorph: theMorph].
	self scrollSelectionIntoView! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/17/2009 23:01'!
setSelectionSelector
	^ setSelectionSelector ifNil: [setSelectionSelector := #selection:]! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/1/2009 18:10'!
setSelectionSelector: aSelector
	setSelectionSelector := aSelector! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/26/2009 08:04'!
shiftSelectMorph: aNodeMorph 
	| idx1 idx2 m |
	m := aNodeMorph ifNil: [scroller submorphs last].
	(lastSelectedMorph isNil or: [(self selectedMorphList isEmpty)])
		ifTrue: [^ self selectMorph: m multiple: true].
	idx1 := ((self getSelectionIndexOf: lastSelectedMorph) min: scroller submorphs size) max: 1.
	idx2 := ((self getSelectionIndexOf: m) min: scroller submorphs size) max: 1.
	self emptySelection.
	idx1 < idx2 
		ifTrue: [self selectFrom: idx1 to: idx2]
		ifFalse: [self selectFrom: idx2 to: idx1].
	^ m path collect: [:p | p complexContents]
! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'alain.plantec 10/12/2009 23:25'!
sortingSelector: s

	sortingSelector := s! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'alain.plantec 10/16/2009 16:16'!
startDrag: evt 
	| ddm itemMorph passenger |
	self dragEnabled
		ifTrue: [itemMorph := scroller submorphs
						detect: [:any | any highlightedForMouseDown]
						ifNone: []].
	(itemMorph isNil
			or: [evt hand hasSubmorphs])
		ifTrue: [^ self].
	itemMorph highlightForMouseDown: false.
	
	itemMorph ~= self selectedMorph
		ifTrue: [self setSelectedMorph: itemMorph].
	passenger := self model dragPassengerFor: itemMorph inMorph: self.
	passenger
		ifNotNil: [ddm := TransferMorph withPassenger: passenger from: self.
			ddm
				dragTransferType: (self model dragTransferTypeForMorph: self).
			evt hand grabMorph: ddm].
	evt hand releaseMouseFocus: self! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/11/2009 21:14'!
swapColumn: aColumn withColumn: anotherColumn
	self swapColumnAt:  aColumn index withColumnAt: anotherColumn index! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/15/2009 19:27'!
swapColumnAt: oneIndex withColumnAt: anotherIndex
	self columns swap: oneIndex with: anotherIndex. 
	self columnsChanged.
	self list: self getList.
	self updateColumnMorphs.
	self columnResizersToFront
! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'alain.plantec 10/12/2009 23:25'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!MorphTreeMorph methodsFor: 'drawing' stamp: 'alain.plantec 10/12/2009 23:25'!
themeChanged
	"Update the selection colour."

	self selectionColor ifNotNil: [
		self selectionColor: self theme selectionColor].
	super themeChanged! !

!MorphTreeMorph methodsFor: 'keyboard navigation' stamp: 'AlainPlantec 11/15/2009 15:34'!
toggleExpandedState: aMorph
	aMorph toggleExpandedState.
	self adjustSubmorphPositions.

! !

!MorphTreeMorph methodsFor: 'events' stamp: 'AlainPlantec 11/15/2009 15:33'!
toggleExpandedState: aMorph event: event
	| oldState |
	event yellowButtonPressed ifTrue: [
		oldState := aMorph isExpanded.
		scroller submorphs copy do: [ :each |
			(each canExpand and: [each isExpanded = oldState]) ifTrue: [
				each toggleExpandedState.
			].
		].
	] ifFalse: [
		aMorph toggleExpandedState.
	].
	self adjustSubmorphPositions.
	! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 10/29/2009 10:08'!
toggleImageHeight
	^ self expandedToggleImage height max: self notExpandedToggleImage height.! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 10/29/2009 10:08'!
toggleImageWidth
	^ self expandedToggleImage width max: self notExpandedToggleImage width.! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/8/2009 18:41'!
topHeader
	^ topHeader ! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/9/2009 15:25'!
topHeaderBackground
	^ topHeaderBackground ifNil: [topHeaderBackground := Color transparent]! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/9/2009 10:54'!
topHeaderBackground: aFillStyle
	topHeaderBackground := aFillStyle! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/9/2009 13:24'!
topHeaderHeight
	| h |
	self topHeader 
		ifNil: [^ 0] 
		ifNotNil: [:th | 
			h := th borderWidth * 2.
			self columns do: [:col | h := h max: col height].
			^ h]
		! !

!MorphTreeMorph methodsFor: 'drawing' stamp: 'AlainPlantec 11/26/2009 07:48'!
unhighlightSelection
	self selectedMorphList do: [:it | it unhighlight]! !

!MorphTreeMorph methodsFor: 'updating' stamp: 'AlainPlantec 11/27/2009 22:12'!
update: aSymbol
	aSymbol == #selection ifTrue: [^ self updateSelectionFromModel].
	aSymbol == getListSelector ifTrue: [^ self updateList].
	((aSymbol isKindOf: Array) 
		and: [aSymbol size > 1 and: [aSymbol first == getListSelector and: [
					aSymbol second == #openPath]]]) "allow directed path opening where multiple trees exist"
			ifTrue: 
				[^(scroller submorphs at: 1 ifAbsent: [^self]) 
					openPath: (aSymbol allButFirst: 2)].
	((aSymbol isKindOf: Array) 
		and: [aSymbol size > 1 and: [aSymbol first == getListSelector and: [
					aSymbol second == #openItemPath]]]) "allow directed path opening where multiple trees exist"
			ifTrue: 
				[^ (scroller submorphs at: 1 ifAbsent: [^self]) 
					openItemPath: (aSymbol allButFirst: 2)].
	((aSymbol isKindOf: Array) 
		and: [aSymbol size > 1 and: [aSymbol first == getListSelector and: [
					aSymbol second == #closeItemPath]]]) "allow directed path closing where multiple trees exist"
			ifTrue: 
				[^ (scroller submorphs at: 1 ifAbsent: [^self]) 
					closeItemPath: (aSymbol allButFirst: 2)].
	((aSymbol isKindOf: Array) 
		and: [aSymbol notEmpty and: [aSymbol first == #openPath]]) 
			ifTrue: 
				[^(scroller submorphs at: 1 ifAbsent: [^self]) 
					openPath: aSymbol allButFirst].
	((aSymbol isKindOf: Array) 
		and: [aSymbol size  = 2 and: [aSymbol first = getListSelector and: [
					aSymbol second == #expandRoots]]]) 
			ifTrue: 
				[^self expandRoots].
	((aSymbol isKindOf: Array) 
		and: [aSymbol notEmpty and: [aSymbol first = getListSelector and: [
					aSymbol second == #expandAll]]]) 
			ifTrue: 
				[^self expandAll]! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/15/2009 15:01'!
updateColumnMorphs
	self resetRootInfo.
	self updateTopHeader.
	self updateColumnMorphsWidth.
	self innerWidgetChanged.
! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/15/2009 15:32'!
updateColumnMorphsWidth
	| controlWidths |
	controlWidths := self controlWidths.
	self scroller submorphsDo: [:i | i updateColumnMorphsWidthWith: controlWidths].
	self adjustSubmorphPositions.! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/12/2009 21:18'!
updateColumnResizersHeight
	self columnResizers do: [:col | | b |
		b :=  col bounds.
		b := b left @ self top corner: b right @ scroller bottom.
		col bounds: b].
! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/18/2009 09:54'!
updateColumnResizersXOffset
	self columnResizerFrames with: self columnResizers do: [:frm :resizer | resizer bounds: (frm withBottom: scroller bottom)].
! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 12/1/2009 16:06'!
updateFromSelection: aSelection
	self setSelectedNodeItemList: (aSelection selectedNodePathList collect: [:p | p last item ])! !

!MorphTreeMorph methodsFor: 'updating' stamp: 'AlainPlantec 11/16/2009 08:40'!
updateList
	self list: self getList.
	self updateColumnMorphs
! !

!MorphTreeMorph methodsFor: 'selection' stamp: 'AlainPlantec 11/19/2009 13:45'!
updateSelectionFromModel
	self emptySelection.
	(model perform: self getSelectionSelector) 
		ifNotNil: [:selHolder | selHolder updateView: self].
! !

!MorphTreeMorph methodsFor: 'column handling' stamp: 'AlainPlantec 11/11/2009 12:07'!
updateTopHeader
	| w |
	self topHeader ifNotNil: [:th |
		th width: scroller width .
		w := self headerBounds.
		th submorphsDo: [:sm | w ifNotEmpty: [sm bounds: w removeFirst]]].
! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'alain.plantec 10/23/2009 09:02'!
vCellInset
	^ vCellInset ifNil: [vCellInset := 0]! !

!MorphTreeMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/15/2009 18:17'!
vCellInset: anInteger
	vCellInset := anInteger.
! !

!MorphTreeMorph methodsFor: 'scrolling' stamp: 'AlainPlantec 11/15/2009 14:49'!
vScrollBarValue: scrollValue
	super vScrollBarValue: scrollValue! !

!MorphTreeMorph methodsFor: 'scrolling' stamp: 'alain.plantec 10/12/2009 23:25'!
vUnadjustedScrollRange
"Return the width of the widest item in the list"

	(scroller submorphs size > 0) ifFalse:[ ^0 ].
	^scroller submorphs last fullBounds bottom
! !

!MorphTreeMorph methodsFor: 'dropping/grabbing' stamp: 'AlainPlantec 11/11/2009 18:19'!
wantsDroppedMorph: aMorph event: anEvent 
	^ self model wantsDroppedMorph: aMorph event: anEvent inMorph: self! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:08'!
withHLines
	^ withHLines ifNil: [withHLines := false]! !

!MorphTreeMorph methodsFor: 'accessing' stamp: 'AlainPlantec 10/29/2009 10:08'!
withHLines: aBoolean
	withHLines := aBoolean! !

!MorphTreeMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/26/2009 07:48'!
yellowButtonEvent: anEvent
	(self scrollerSubMorphFromPoint: anEvent position) ifNotNil: [:sel |
		(self selectedMorphList includes: sel) ifFalse: [self setSelectedMorph: sel].
		self yellowButtonActivity: anEvent shiftPressed.
		^ true.
	].
	^ false! !

Object subclass: #MorphTreeColumn
	instanceVariableNames: 'header container currentWidth rowMorphGetSelector shrinkWrap defaultRowMorph color isPotentialDropTarget resizable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!MorphTreeColumn methodsFor: 'converting' stamp: 'AlainPlantec 11/12/2009 08:01'!
asDraggableMorph
	^ self thumbnailOfSize: self header fullBounds extent
	! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2009 19:12'!
asPotentialDropTarget
	isPotentialDropTarget := true.
	self container invalidRect: self visibleBounds! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2009 14:01'!
buttonHeader
	self header: ((MorphTreeColumnButton new) 
		layoutPolicy: TableLayout new; 
		listDirection: #leftToRight; 
		listCentering: #leftCenter; 
		wrapCentering: #center;
		cellInset: 3@0;
		yourself)! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2009 19:44'!
color 
	^ color ifNil: [self container columnColors at: ((self index \\ 2) + 1)]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2009 18:52'!
color: aColor
	color := aColor! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 09:47'!
container
	^ container! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/3/2009 16:38'!
container: aTreeMorph
	container := aTreeMorph! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 17:31'!
contentWidth
	| w |
	w := 0.
	self container allNodes do: [:n | w := w max: (n columnMorphAt: self index) width].
	^ w! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 10:15'!
currentWidth
	^ currentWidth ifNil: [currentWidth := self defaultWidth]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/18/2009 10:22'!
currentWidth: anInteger
	self resizable ifTrue: [currentWidth := anInteger]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2009 18:54'!
dataBounds 
	^ self visibleBounds withTop: self container topHeader bottom! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 11:29'!
defaultRowMorph
	^ Morph new color: Color red; borderWidth: 0; extent: 0@0; yourself
! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 10:15'!
defaultWidth
	^ 100! !

!MorphTreeColumn methodsFor: 'column drawing' stamp: 'AlainPlantec 11/18/2009 10:07'!
drawColumnOn: aCanvas
	self isPotentialDropTarget 
		ifTrue: [aCanvas 
					frameAndFillRectangle: self dataBounds 
					fillColor: ((Color gray alpha: 0.1) alphaMixed: 0.9 with: (self color ifNotNil: [:c | c asColor] ifNil: [Color transparent]))
					borderWidth: 2 
					borderColor: Color gray]
		ifFalse: [self color 
						ifNotNil: [:c | 
							c isColor 
								ifTrue: [
									aCanvas 
										frameAndFillRectangle: self dataBounds 
										fillColor: self color
										borderWidth: 0 
										borderColor: Color transparent]
								ifFalse: [c origin: self dataBounds topLeft.
									c direction: 0@self dataBounds height.
									aCanvas fillRectangle: self dataBounds  basicFillStyle: c]]]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/18/2009 10:22'!
fixedWidth: anInteger
	currentWidth := anInteger.
	resizable := false! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/18/2009 10:47'!
forceWidthTo: anInteger
	currentWidth := anInteger! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/9/2009 15:26'!
header
	^ header ifNil: [header :=  (Morph new extent: 0@0) color: Color transparent]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 20:55'!
header: aMorph
	header := aMorph clipSubmorphs: true; yourself.
	header model: self! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 17:59'!
headerButtonLabel: aLabel font: aFont
	self buttonHeader.
	self header label: aLabel font: aFont.

! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 18:05'!
headerButtonLabel: aLabel font: aFont icon: anIconForm target: aReceiver actionSelector: aSelector arguments: aCollection
	self buttonHeader.
	self header label: aLabel font: aFont.
	self header addMorphFront: (ImageMorph new image: anIconForm).
	self header actionSelector: aSelector.
	self header target: aReceiver.
	self header arguments: aCollection
	! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'tg 11/16/2009 06:06'!
headerButtonLabel: aLabel font: aFont target: aReceiver actionSelector: aSelector arguments: aCollection
	self buttonHeader.
	self header label: aLabel font: aFont.
	self header actionSelector: aSelector.
	self header target: aReceiver.
	self header arguments: aCollection
	! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 17:52'!
headerButtonLabel: aLabel icon: anIconForm
	self headerButtonLabel: aLabel.
	self header cellInset: 3@0.
	self header addMorphFront: (ImageMorph new image: anIconForm)! !

!MorphTreeColumn methodsFor: 'geometry' stamp: 'AlainPlantec 11/4/2009 21:52'!
height
	^ header ifNil: [0] ifNotNil: [header height]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 21:07'!
index
	^ self container columns indexOf: self! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2009 19:11'!
isPotentialDropTarget
	^ isPotentialDropTarget ifNil: [isPotentialDropTarget := false]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2009 19:13'!
noMorePotentialDropTarget
	isPotentialDropTarget := false.
	self container invalidRect: self visibleBounds! !

!MorphTreeColumn methodsFor: 'initialize-release' stamp: 'AlainPlantec 11/3/2009 22:16'!
release
	container := nil.
	header := nil.
	super release.! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/18/2009 09:52'!
resizable
	^ resizable ifNil: [resizable := true]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/18/2009 09:53'!
resizable: aBoolean
	resizable := aBoolean! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 09:26'!
rowMorphFor: aNodeMorph
	| rowMorph |
	self rowMorphGetSelector ifNil: [^ self defaultRowMorph].
	rowMorph := self rowMorphGetSelector numArgs = 0 
		ifTrue: [aNodeMorph perform: self rowMorphGetSelector]
		ifFalse: [aNodeMorph perform: self rowMorphGetSelector with: self container].
	^ rowMorph ifNil: [self defaultRowMorph]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/9/2009 19:04'!
rowMorphGetSelector
	^ rowMorphGetSelector! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/9/2009 19:05'!
rowMorphGetSelector: aSelector
	rowMorphGetSelector := aSelector! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/18/2009 11:48'!
shrinkWrap
	^ shrinkWrap ifNil: [shrinkWrap := false]! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/18/2009 11:48'!
shrinkWrap: aBoolean
	shrinkWrap := aBoolean! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 10:16'!
startWidth: anInteger
	currentWidth := anInteger! !

!MorphTreeColumn methodsFor: 'converting' stamp: 'AlainPlantec 11/12/2009 08:02'!
thumbnailOfSize: thumbExtent
	"Answer a new thumbnail for the receiver."

	|f t r|
	r := self header fullBounds scaledAndCenteredIn: (0@0 extent: thumbExtent).
	f := Form extent: r extent depth: Display depth.
	t := MatrixTransform2x3 withScale: 1.0.
	f getCanvas
		transformBy: t
		clippingTo: f boundingBox
		during: [:c | c translateBy: self visibleBounds topLeft negated during: [:ct | self container fullDrawOn: ct]]
		smoothing: 6.
	^ImageMorph new
		image: f! !

!MorphTreeColumn methodsFor: 'accessing' stamp: 'AlainPlantec 11/12/2009 07:57'!
visibleBounds
	^ self header bounds withBottom: self container scroller bottom! !

Object subclass: #MorphTreeMorphSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

MorphTreeMorphSelection subclass: #MorphTreeMorphMultipleSelection
	instanceVariableNames: 'selectedNodePathList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!MorphTreeMorphMultipleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:27'!
lastSelectedNodePath
	^ self selectedNodePathList ifNotEmpty: [:l | l last]! !

!MorphTreeMorphMultipleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 18:13'!
selectedItemOrItemsOrNil
	| theItems |
	theItems := self selectedNodeList collect: [ :each | each item ].
	^ theItems isEmpty ifTrue: [nil] ifFalse: [ theItems ]! !

!MorphTreeMorphMultipleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 18:15'!
selectedNodeList
	^ self selectedNodePathList 
		ifNil: [#()]
		ifNotNil: [:l | l collect: [:path | path last]]! !

!MorphTreeMorphMultipleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 22:04'!
selectedNodePathList
	^ selectedNodePathList ifNil: [selectedNodePathList := #()]! !

!MorphTreeMorphMultipleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 22:05'!
selectedNodePathList: aCollectionOfPath
	selectedNodePathList := aCollectionOfPath! !

!MorphTreeMorphMultipleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 18:13'!
selectedNodes
	^ OrderedCollection withAll: self selectedNodeList
! !

!MorphTreeMorphSelection methodsFor: 'accessing' stamp: 'AlainPlantec 1/11/2010 13:41'!
lastSelectedNode
	^ self lastSelectedNodePath ifNotNil: [:path | path ifEmpty: [nil] ifNotEmpty: [:p | path last]]! !

!MorphTreeMorphSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:26'!
lastSelectedNodePath 
	^ self subclassResponsibility! !

!MorphTreeMorphSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 18:11'!
selectedItemOrItemsOrNil
	^ self lastSelectedNode isNil 
		ifTrue: [ nil ]
		ifFalse: [ self lastSelectedNode item ]! !

!MorphTreeMorphSelection methodsFor: 'accessing' stamp: 'AlainPlantec 12/1/2009 06:36'!
selectedNodePathList
	^ self subclassResponsibility! !

!MorphTreeMorphSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 18:11'!
selectedNodes
	^ OrderedCollection with: self lastSelectedNode! !

!MorphTreeMorphSelection methodsFor: 'view updating' stamp: 'AlainPlantec 12/1/2009 06:38'!
updateView: aTreeMorph 
	aTreeMorph updateFromSelection: self! !

MorphTreeMorphSelection subclass: #MorphTreeMorphSingleSelection
	instanceVariableNames: 'selectedNodePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-MorphTreeWidget'!

!MorphTreeMorphSingleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:25'!
lastSelectedNodePath
	^ self selectedNodePath! !

!MorphTreeMorphSingleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:24'!
selectedNodePath
	^ selectedNodePath! !

!MorphTreeMorphSingleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:11'!
selectedNodePath: aSelectionPath
	selectedNodePath := aSelectionPath! !

!MorphTreeMorphSingleSelection methodsFor: 'accessing' stamp: 'AlainPlantec 12/1/2009 08:31'!
selectedNodePathList
	^ self selectedNodePath ifNil: [#()] ifNotNil: [Array with: self selectedNodePath]! !
